.DATA
ALIGN 16
;
; ici, ce sont les tmoins concernant les informations du microprocesseur
;
_Temoins_Aptitudes_Du_MicroProcesseur_	DWORD ?
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
; bit 12 =

;_Temoin_Type_Du_MicroProcesseur_		DWORD ?
;
;
;
;
;


.CODE
ALIGN 16
;
; obtenir des informations sur le microprocesseur qui utilise le programme
;
; Syntaxe :
; call DefinirAptitudesDuProcesseur
;
; Retourne :
; eax et la variable _Temoins_Aptitudes_Du_MicroProcesseur_ sont dfinis avec les bits positionns
;
DefinirAptitudesDuProcesseur PROC
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi

		xor esi,esi									;; mettre esi (le registre qui stockera les bits)  0
; l'instruction CPUID est supporte, seulement s'il est possible de positionner/enlever le flag ID (EFLAGS bit 21).
		pushfd										;; ) copier les flags+flags etendus dans eax et edx
		pop eax										;; )
		mov edx,eax									;; )
		btc eax,21									;; inverser le flag ID (bit 21)
		push eax										;; ) et recopier le rsultat dans les flags
		popfd										;; )
		pushfd										;;	) puis on recopie  nouveau les flags dans eax
		pop eax										;;	)
		cmp eax,edx									;; comparer le rsultat  notre prcdente sauvegarde
		je PasSupportCpuid								;; si c'est semblable, c'est que notre modif n'a eu aucun effet, alors aller PasSupportCpuid
		bts esi,0										;; positionner le bit correspondant dans esi

; ici, l'instruction cpuid est supporte, on va donc s'en servir pour connaitre les aptitudes du processeur
;		mov eax,0										;; ici, on dtermine le type d'infos que l'on veut rcuprer
;		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
;													;; (eax contient le nombre d'entres cpuid maximales)

; ici, on passe aux informations suivantes
		mov eax,1										;; ici, on dtermine les infos les plus importantes (du moins pour la programmation)
		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
													;; (eax contient le type, le model,la famille,...)
													;; (edx contient les caractristiques disponibles)
; les instructions fpu sont disponibles ?
		bt edx,0										;; tester le bit 0
		jnc PasSupportFpu								;; si le flag carry n'est pas positionn, aller PasSupportFpu
		bts esi,1										;; positionner le bit correspondant dans esi
PasSupportFpu:
; l'instruction rdtsc est disponible ?
		bt edx,4										;; tester le bit 4
		jnc PasSupportRdtsc								;; si le flag carry n'est pas positionn, aller PasSupportRdtsc
		bts esi,2										;; positionner le bit correspondant dans esi
PasSupportRdtsc:
; l'instruction CmpXchg8b est disponible ?
		bt edx,8										;; tester le bit 8
		jnc PasSupportCmpXchg8b							;; si le flag carry n'est pas positionn, aller PasSupportCmpXchg8b
		bts esi,3										;; positionner le bit correspondant dans esi
PasSupportCmpXchg8b:
; les instructions cmov sont disponibles ?
		bt edx,15										;; tester le bit 15
		jnc PasSupportCmov								;; si le flag carry n'est pas positionn, aller PasSupportCmov
		bts esi,4										;; positionner le bit correspondant dans esi
PasSupportCmov:
; les instructions clfsh sont disponibles ?
		bt edx,19										;; tester le bit 19
		jnc PasSupportClfsh								;; si le flag carry n'est pas positionn, aller PasSupportClfsh
		bts esi,5										;; positionner le bit correspondant dans esi
PasSupportClfsh:
; les instructions mmx sont disponibles ?
		bt edx,23										;; tester le bit 23
		jnc PasSupportMmx								;; si le flag carry n'est pas positionn, aller PasSupportMmx
		bts esi,6										;; positionner le bit correspondant dans esi
PasSupportMmx:
; les instructions fxsr sont disponibles ?
		bt edx,24										;; tester le bit 24
		jnc PasSupportFxsr								;; si le flag carry n'est pas positionn, aller PasSupportFxsr
		bts esi,7										;; positionner le bit correspondant dans esi
PasSupportFxsr:
; les instructions sse sont disponibles ?
		bt edx,25										;; tester le bit 25
		jnc PasSupportSse								;; si le flag carry n'est pas positionn, aller PasSupportSse
		bts esi,8										;; positionner le bit correspondant dans esi
PasSupportSse:
; les instructions sse2 sont disponibles ?
		bt edx,26										;; tester le bit 26
		jnc PasSupportSse2								;; si le flag carry n'est pas positionn, aller PasSupportSse2
		bts esi,9										;; positionner le bit correspondant dans esi
PasSupportSse2:
; les instructions htt sont disponibles ?
		bt edx,28										;; tester le bit 28
		jnc PasSupportHtt								;; si le flag carry n'est pas positionn, aller PasSupportHtt
		bts esi,10									;; positionner le bit correspondant dans esi
PasSupportHtt:
; les instructions sse3 sont disponibles ?
		bt ecx,0										;; tester le bit 0
		jnc PasSupportSse3								;; si le flag carry n'est pas positionn, aller PasSupportSse3
		bts esi,11									;; positionner le bit correspondant dans esi
PasSupportSse3:
;; les instructions Xxx sont disponibles ?
;		bt edx,Xxx									;; tester le bit 
;		jnc PasSupportXxx								;; si le flag carry n'est pas positionn, aller
;		bts esi,x										;; positionner le bit correspondant dans esi
;PasSupportXxx:

; ici, on passe aux informations suivantes
;		mov eax,2										;; ici, on dtermine les infos concernant le cache
;		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
PasSupportCpuid:
		mov _Temoins_Aptitudes_Du_MicroProcesseur_,esi		;; sauvegarder les tmoins dans notre variable
		mov eax,esi									;; et les recopier dans eax

		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
	ret												;; retourner, sortir de la procdure
DefinirAptitudesDuProcesseur ENDP


ALIGN 16
;
; positionner une fentre outils  son emplacement logique
;
; Syntaxe :
; mov esi,{pointeur de la fentre}
; mov edi,{OFFSET (adresse) de la structure RECT utilise}
; call PositionnerFenetreOutil
;
; Retourne :
; eax = 0 si erreur
;
; Syntaxe : PositionnerFenetreOutil
;
PositionnerFenetreOutil PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

; positionner la fentre sur la droite de notre cran (en la centrant en hauteur)
		invoke GetWindowRect,esi,edi						;; obtenir les coordonnes de la boite de dialogue
		mov eax,(RECT PTR [edi]).left						;; ) calculer la largeur et la placer dans (RECT PTR [edi]).right
		sub (RECT PTR [edi]).right,eax					;; )
		mov eax,(RECT PTR [edi]).top						;;	) calculer la hauteur et la placer dans (RECT PTR [edi]).bottom
		sub (RECT PTR [edi]).bottom,eax					;;	)
		invoke GetSystemMetrics,SM_CXSCREEN				;; obtenir la taille x de l'ecran os (en pixels)
		sub eax,(RECT PTR [edi]).right					;; soustraire la largeur de notre ecran final
		mov (RECT PTR [edi]).left,eax						;; placer la nouvelle position x
		add (RECT PTR [edi]).right,eax					;; et ajouter la position x  la taille x
		invoke GetSystemMetrics,SM_CYSCREEN				;; obtenir la taille y de l'ecran os (en pixels)
		sub eax,(RECT PTR [edi]).bottom					;; soustraire la largeur de notre ecran final
		sar eax,1										;; pour centrer verticalement
		mov (RECT PTR [edi]).top,eax						;; placer la nouvelle position Y
		add (RECT PTR [edi]).bottom,eax					;; et ajouter la position y  la taille y
		invoke GetSystemMetrics,SM_CXVSCROLL				;; ) enlever la largeur d'une barre de scrolling verticale
		sub (RECT PTR [edi]).left,eax						;; )
		sub (RECT PTR [edi]).right,eax					;; )
		invoke GetSystemMetrics,SM_CXBORDER				;; ) (ici, avec les bordures)
		add eax,eax									;; plus rapide que :
;		shl eax,1										;; 
		sub (RECT PTR [edi]).left,eax						;; )
		sub (RECT PTR [edi]).right,eax					;; )
		invoke SetWindowPos,esi,NULL,(RECT PTR [edi]).left,(RECT PTR [edi]).top,NULL,NULL,SWP_NOSIZE or SWP_NOZORDER

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner, sortir de la procdure
PositionnerFenetreOutil ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement date et heure
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Date_Chaine_Valeur_			BYTE 0,0,0,0,0,0,0,0,0,0,0,0
_Date_Chaine_Separation_Date_		BYTE "/",0
_Date_Chaine_Separation_Date_2_	BYTE " ",0
_Date_Chaine_Separation_Heure_	BYTE ":",0


_Date_Informations_Date_			SYSTEMTIME <?>
;SYSTEMTIME STRUCT
;	wYear		WORD	?								;; l'anne en cours (de  )
;	wMonth		WORD ?								;; le mois de l'anne (de 1  12)
;	wDayOfWeek	WORD	?								;; le jour de la semaine (de 0  6) 0=dimanche, 1=lundi, ...
;	wDay			WORD	?								;; le jour du mois (de 1  28/29/30/31)
;	wHour		WORD	?								;; l'heure du jour (de 0  23)
;	wMinute		WORD	?								;; le nombre de minutes (de 0  59)
;	wSecond		WORD	?								;; le nombre de secondes (de 0  59)
;	wMilliseconds	WORD	?								;; le nombre de millisecondes (de 0  999)
;SYSTEMTIME ENDS


.CODE
ALIGN 16
;
; definir la date et l'heure, ici on rempli la structure SYSTEMTIME qui permettra aux autres fonctions d'obtenir
; les informations dsires (doit tre appele chaque fois que les informations doivent tre mises  jour)
;
; Syntaxe :
; call DefinirDateEtHeure
;
; Retourne :
; rien
;
DefinirDateEtHeure PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke GetLocalTime,ADDR _Date_Informations_Date_		;; obtenir les informations

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
DefinirDateEtHeure ENDP


ALIGN 16
;
; obtenir la date (jour/mois/anne) ici, on n'utilise que des chiffres
; note : c'est plus rapide si edi pointe exactement  l'emplacement o on ajoutera la chane, mais dans ce cas l,
; eax retournera uniquement la taille de la chane ajoute
;
; Syntaxe :
; mov edi,{OFFSET (adresse) de la chaine qui doit recevoir la valeur (elle sera ajoute  la suite si la chane de destination n'est pas vide)}
; call ObtenirDate
;
; Retourne :
; eax = la taille de la chaine ou la taille de la chaine ajoute (suivant que edi contenait l'adresse de dpart ou l'adresse de fin de la chaine de destination)
;
ObtenirDate PROC
		push esi										;; empiler esi
		push edi										;; empiler edi

; pour le jour
		movzx eax,_Date_Informations_Date_.wDay				;; lire le jour
		mov esi,OFFSET _Date_Chaine_Valeur_				;; placer l'adresse de la chaine dans esi
		cmp eax,10									;; comparer la valeur  10
		jae EviterPlacerZero_1							;; si c'est suprieur ou gal, aller EviterPlacerZero_1
		mov BYTE PTR [esi],"0"							;; sinon, placer un zro  l'adresse en esi
		inc esi										;; et incrmenter l'adresse de la chane qui contiendra la valeur
EviterPlacerZero_1:
		call ConvertirValeurEnChaineDecimale				;; convertir la valeur en chaine
		mov esi,OFFSET _Date_Chaine_Valeur_				;; placer l'adresse de la chaine dans esi (ncessaire  cause des lignes prcdentes)
;		mov edi,OFFSET									;; placer l'emplacement de rception dans edi
		call FusionnerChainesAscii						;; fusionner la chaine  celle du tampon
; le sparateur pour la date
		mov esi,OFFSET _Date_Chaine_Separation_Date_			;; placer l'adresse de la chaine de sparation
		add edi,eax									;; ajouter la taille obtenue  l'adresse de destination
		call FusionnerChainesAscii						;; fusionner la chaine  celle du tampon
; pour le mois
		movzx eax,_Date_Informations_Date_.wMonth			;; lire le mois
		mov esi,OFFSET _Date_Chaine_Valeur_				;; placer l'adresse de la chaine dans esi
		cmp eax,10									;; comparer la valeur  10
		jae EviterPlacerZero_2							;; si c'est suprieur ou gal, aller EviterPlacerZero_2
		mov BYTE PTR [esi],"0"							;; sinon, placer un zro  l'adresse en esi
		inc esi										;; et incrmenter l'adresse de la chane qui contiendra la valeur
EviterPlacerZero_2:
		call ConvertirValeurEnChaineDecimale				;; convertir la valeur en chaine
		mov esi,OFFSET _Date_Chaine_Valeur_				;; placer l'adresse de la chaine dans esi (ncessaire  cause des lignes prcdentes)
;		mov edi,OFFSET									;; placer l'emplacement de rception dans edi
		call FusionnerChainesAscii						;; fusionner la chaine  celle du tampon
; le sparateur pour la date
		mov esi,OFFSET _Date_Chaine_Separation_Date_			;; placer l'adresse de la chaine de sparation
		add edi,eax									;; ajouter la taille obtenue  l'adresse de destination
		call FusionnerChainesAscii						;; fusionner la chaine  celle du tampon
; pour l'anne
		movzx eax,_Date_Informations_Date_.wYear			;; lire le nombre de secondes
		mov esi,OFFSET _Date_Chaine_Valeur_				;; placer l'adresse de la chaine dans esi
		sub eax,2000									;; enlever 2000
		cmp eax,10									;; comparer la valeur  10
		jae EviterPlacerZero_3							;; si c'est suprieur ou gal, aller EviterPlacerZero_3
		mov BYTE PTR [esi],"0"							;; sinon, placer un zro  l'adresse en esi
		inc esi										;; et incrmenter l'adresse de la chane qui contiendra la valeur
EviterPlacerZero_3:
		call ConvertirValeurEnChaineDecimale				;; convertir la valeur en chaine
		mov esi,OFFSET _Date_Chaine_Valeur_				;; placer l'adresse de la chaine dans esi (ncessaire  cause des lignes prcdentes)
;		mov edi,OFFSET									;; placer l'emplacement de rception dans edi
		call FusionnerChainesAscii						;; fusionner la chaine  celle du tampon

		pop edi										;; dsempiler edi
		mov esi,edi									;; copier edi dans esi
		call ObtenirTailleChaineAscii						;; obtenir la taille suivant ce que contenait edi
		pop esi										;; dsempiler esi
	ret												;; retourner (sortir de la procdure)
ObtenirDate ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement de fichiers
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Fichier_Octets_Lus_					DWORD ?
_Fichier_Pointeur_Fichier_Temporaire_		DWORD ?
_Fichier_Octets_Ecrits_					DWORD ?
_Fichier_Complement_Alignement_			DWORD ?

_Fichier_Chaine_Chemin_Temporaire_			BYTE MAX_PATH dup (?)		;; MAX_PATH = 260
_Fichier_Chaine_Chemin_Temporaire_Ajout		BYTE "\",0
_Fichier_Chaine_Chemin_Temporaire_Ajout_2	BYTE "Fichier",0			;; ca c'est necessaire pour openfilename ou opensavename

_Fichier_Chaine_Production_				BYTE "NightWare Production",0
_Fichier_Chaine_Alignement_				BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


;Chaine_Filtre_De_Selection_Fichiers			BYTE "Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Clefs		BYTE "Clefs de cryptage/dcryptage (*.cuk)",0,"*.cuk",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Compresses	BYTE "Fichiers compresss (*.7z,*.lha,*.rar,*.zip)",0,"*.7z;*.lha;*.rar;*.zip",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Cryptes		BYTE "Fichiers crypts (*.crypted)",0,"*.crypted",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Donnees		BYTE "Donnes (*.dat,*.raw)",0,"*.dat;*.raw",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Executables	BYTE "Executables (*.exe,*.hlp)",0,"*.exe;*.hlp",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Images		BYTE "Images (*.bmp,*.dib,*.gif,*.jpg,*.raw)",0,"*.bmp;*.dib;*.gif;*.jpg;*.raw",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Textes		BYTE "Textes (*.asm,*.doc,*.inc,*.txt,*.x)",0,"*.asm;*.doc;*.inc;*.txt;*.x",0,"Tous fichiers (*.*)",0,"*.*",0,0

;Chaine_Extension_Clef_Par_Defaut			BYTE "cuk",0			;; abbrviation de "crypt uncrypt key"
;Chaine_Extension_Compresse_Par_Defaut		BYTE "zip",0
;Chaine_Extension_Crypte_Par_Defaut			BYTE "crypted",0		;; fichier crypt
;Chaine_Extension_Donnees_Par_Defaut		BYTE "dat",0
;Chaine_Extension_Executable_Par_Defaut		BYTE "exe",0
;Chaine_Extension_Image_Par_Defaut			BYTE "bmp",0
;Chaine_Extension_Texte_Par_Defaut			BYTE "txt",0
;
;Chaine_Type_De_Selection_Chargement_Fichier	BYTE "Dfinissez le fichier  charger.",0
;Chaine_Type_De_Selection_Sauvegarde_Fichier	BYTE "Dfinissez le fichier  sauvegarder.",0
;Chaine_Type_De_Selection_Chargement_Clef	BYTE "Dfinissez la clef  charger.",0
;Chaine_Type_De_Selection_Sauvegarde_Clef	BYTE "Dfinissez la clef  sauvegarder.",0

; les messages d'erreur
;_Fichier_Chaine_Message_Erreur_NonSelection_			BYTE "aucun fichier n'a t slectionn !",0
;_Fichier_Chaine_Message_Erreur_Taille_				BYTE "le fichier est trop volumineux !",0

ALIGN 16
_Fichier_Information_Selection_ OPENFILENAME <?>
;OPENFILENAME STRUCT
;	lStructSize		DWORD ?							;; taille de la structure (en octets)
;	hwndOwner			DWORD ?							;; intance de la fentre (HWnd)
;	hInstance			DWORD ?							;; intance d'une fenetre personalise (le flag OFN_ENABLETEMPLATEHANDLE doit tre slectionn)
;	lpstrFilter		DWORD ?							;; pointeur contenant une paire de filtre
;	lpstrCustomFilter	DWORD ?							;; pointeur contenant une paire de filtre personnalis (ignor si = 0)
;	nMaxCustFilter		DWORD ?							;; taille en octets des filtres personnalis (ignor si = 0)
;	nFilterIndex		DWORD ?							;; n du filtre par dfaut (le numro est fonction de l'ordre des filtres)
;	lpstrFile			DWORD ?							;; pointeur d'une chane (drive/chemin/fichier.extension)
;	nMaxFile			DWORD ?							;; taille maximale en octets de la chane (drive/chemin/fichier.extension)
;	lpstrFileTitle		DWORD ?							;; pointeur d'une chane (fichier.extension)
;	nMaxFileTitle		DWORD ?							;; taille maximale en octets de la chane (fichier.extension) (ignor si = 0)
;	lpstrInitialDir	DWORD ?							;; pointeur sur la chane (drive/chemin) (ou rpertoire actuel si = 0)
;	lpstrTitle		DWORD ?							;; pointeur de la chane qui apparaitra comme titre dans la barre de la boite de dialogue
;	Flags			DWORD ?							;; flags d'initialisation de la boite de dialogue
;	nFileOffset		WORD ?							;; position o se situe le nom du fichier dans la chane (drive/chemin/fichier.extension)
;	nFileExtension		WORD ?							;; position o se situe l'extension dans la chane (drive/chemin/fichier.extension)
;	lpstrDefExt		DWORD ?							;; pointeur d'une chane extension (sans le point) par dfaut qui sera appliqu si l'utilisateur n'en entre pas (ignor si = 0)
;	lCustData			DWORD ?							;; (ignor si lpfnHook est inactif)
;	lpfnHook			DWORD ?							;; (ignor si OFN_ENABLEHOOK n'est pas slectionn)
;	lpTemplateName		DWORD ?							;; (ignor si OFN_ENABLETEMPLATE n'est pas slectionn)
;OPENFILENAME ENDS

ALIGN 16
_Fichier_Information_Fichier_ WIN32_FIND_DATA <?>
;WIN32_FIND_DATA STRUCT
;	dwFileAttributes	DWORD ?							;; attributs du fichier ou du rpertoire
;; (FILE_ATTRIBUTE_ARCHIVE, FILE_ATTRIBUTE_COMPRESSED, FILE_ATTRIBUTE_DIRECTORY, FILE_ATTRIBUTE_HIDDEN,
;; FILE_ATTRIBUTE_NORMAL, FILE_ATTRIBUTE_OFFLINE, FILE_ATTRIBUTE_READONLY, FILE_ATTRIBUTE_SYSTEM, FILE_ATTRIBUTE_TEMPORARY)
;	ftCreationTime		FILETIME <?>						;; date concernant la cration du fichier
;	ftLastAccessTime	FILETIME <?>						;; date concernant le dernier accs au fichier
;	ftLastWriteTime	FILETIME <?>						;; date concernant la dernire modification du fichier
;	nFileSizeHigh		DWORD ?							;; ) taille du fichier
;	nFileSizeLow		DWORD ?							;; )
;	dwReserved0		DWORD ?							;;	) inutiliss pour le moment
;	dwReserved1		DWORD ?							;;	)
;	cFileName			BYTE MAX_PATH dup (?)				;; nom du fichier
;	cAlternateFileName	BYTE 14 dup (?)					;; nom coup dos (8+3) du fichier (ou 0 si cFileName est dj compatible dos)
;WIN32_FIND_DATA ENDS

;FILETIME STRUCT
;	dwLowDateTime		DWORD ?							;; ) valeur 64 bits reprsentant le nombre d'intervales
;	dwHighDateTime		DWORD ?							;; ) de 100 nanosecondes, depuis le 1er janvier 1601
;FILETIME ENDS


;ALIGN 16
;_Fichier_Information_Execution_ SHELLEXECUTEINFO <?>
;;SHELLEXECUTEINFO STRUCT
;;	cbSize			DWORD ?							;; taille de la structure (en octets)
;;	fMask			DWORD ?							;; masque des options de la structure
;;	hwnd				DWORD ?							;; intance de la fentre (HWnd)
;;	lpVerb			DWORD ?							;; adresse d'une chane verbe qui dtermine l'action ("Open" par dfaut)
;;	lpFile			DWORD ?							;; adresse d'une chane (drive/chemin/fichier.extension) ou (fichier.extension), l le rpertoire en cours sera utilis
;;	lpParameters		DWORD ?							;; adresse d'une chane qui contient les parametres  envoyer, ceux ci doivent tre spars d'un espace (pour du texte entre guillemets : \"quoted text\")
;;	lpDirectory		DWORD ?							;; adresse d'une chane (drive/chemin) (le rpertoire en cours est utilis si = 0)
;;	nShow			DWORD ?							;; spcifie comment l'application apparaitra SW_HIDE or SW_MAXIMIZE or SW_MINIMIZE or SW_RESTORE or SW_SHOW or SW_SHOWNORMAL
;;	hInstApp			DWORD ?
;;	lpIDList			DWORD ?							;; pointeur d'une structure ITEMIDLIST (ignor si SEE_MASK_IDLIST n'a pas t dfini dans fMask)
;;	lpClass			DWORD ?							;; adresse d'une chane spcifiant le type de fichier (ignor si SEE_MASK_CLASSNAME n'a pas t dfini dans fMask)
;;	hkeyClass			DWORD ?							;; pointeur de la clef registre pour le type de fichier (ignor si SEE_MASK_CLASSKEY n'a pas t dfini dans fMask)
;;	dwHotKey			DWORD ?							;; scancoe de la touche raccourcis (ignor si SEE_MASK_HOTKEY n'a pas t dfini dans fMask), voir WM_SETHOTKEY
;;	union
;;		hIcon		DWORD ?							;; pointeur pour le type de fichier (ignor si SEE_MASK_ICON n'a pas t dfini dans fMask)
;;		hMonitor		DWORD ?
;;	ends
;;	hProcess			DWORD ?							;; pointeur de la nouvelle application lance (ignor si SEE_MASK_NOCLOSEPROCESS n'a pas t dfini dans fMask)
;;SHELLEXECUTEINFO ENDS

ALIGN 16
_Fichier_Entete_Fichier_Bitmap_ BITMAPFILEHEADER <?>
;BITMAPFILEHEADER STRUCT
;	bfType			WORD ?							;; type de fichier, doit tre BM
;	bfSize			DWORD ?							;; la taille en octets du fichier bitmap
;	bfReserved1		WORD ?							;; rserv, doit tre 0
;	bfReserved2		WORD ?							;; rserv, doit tre 0
;	bfOffBits			DWORD ?							;; spcifie l'adresse (offset) en octets, de la structure vers les pixels du bitmap
;BITMAPFILEHEADER ENDS 

;ALIGN 16
;_Fichier_Entete_Donnees_Bitmap_ BITMAPCOREHEADER <?>
;;BITMAPCOREHEADER STRUCT
;;	bcSize			DWORD ?							;; nombre d'octets requis par la structure
;;	bcWidth			WORD ?							;; spcifie la largeur du bitmap en pixels
;;	bcHeight			WORD ?							;; spcifie la hauteur du bitmap en pixels
;;	bcPlanes			WORD ?							;; spcifie le nombre de plans pour le device de destination
;;	bcBitCount		WORD ?							;; spcifie le nombre de bits utiliss par pixel (ce nombre doit tre 1,4,8 ou 24)
;;BITMAPCOREHEADER ENDS


.CODE
ALIGN 16
;
; charger un fichier bitmap en mmoire (dans un bloc de mme taille) (ncessite comdlg32.lib)
; note : la structure OPENFILENAME concernant le fichier doit avoir t mise  jour si on utilise cette structure
;
; Syntaxe :
; mov ebx,{OFFSET (adresse) de la chane contenant le chemin+nom du fichier (peut tre OPENFILENAME.lpstrFile)}
; mov ecx,{OFFSET (adresse) d'une structure _Pointeurs_Structure_Bitmap_ qui recevra les pointeurs}
; mov esi,{OFFSET (adresse) d'une structure _Informations_Memoire_}
; mov edi,{OFFSET (adresse) d'une structure _Bloc_Memoire_ qui recevera le fichier}
; call ChargerFichier_Bmp
;
; Retourne :
; eax = nombre d'octets lus (ou zro s'il y a une erreur, ou -1 si impossible d'obtenir l'info concernant la taille)
;
ChargerFichier_Bmp PROC
		push edx										;; empiler edx
		push ecx										;; empiler ecx

; obtenir la taille (en octets) du fichier
		invoke FindFirstFile,ebx,ADDR _Fichier_Information_Fichier_ ;; rcuprer les infos du fichier slectionn
		cmp eax,INVALID_HANDLE_VALUE						;; comparer eax  -1
		je PasDeFichierACharger							;; si c'est gal (erreur pointeur), aller PasDeFichierACharger
; sinon, le pointeur est valide
		invoke FindClose,eax							;; alors, supprimer le pointeur dont on n'a plus besion
;		cmp _Fichier_Information_Fichier_.nFileSizeHigh,0		;; ) fichier trop volumineux ?
;		jne Label03									;; )
		mov eax,_Fichier_Information_Fichier_.nFileSizeLow		;; sinon, rcuprer la taille du fichier
; definir la taille du bloc mmoire ncessaire pour charger le fichier
		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax		;; placer cette taille dans x._Taille_Du_Bloc_
		add eax,000000011h								;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets)
; et ajouter 1 galement pour tre sr d'avoir 1 octet pour un zro final (ce qui est pratique pour du texte)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax		;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax		;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax		;; sauvegarder eax dans x._Pointeur_
; lire le fichier
		invoke CreateFile,ebx,GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
		mov _Fichier_Pointeur_Fichier_Temporaire_,eax		;; sauvegarder le pointeur obtenu dans _Fichier_Pointeur_Fichier_Temporaire_
		invoke ReadFile,_Fichier_Pointeur_Fichier_Temporaire_,(_Bloc_Memoire_ PTR [edi])._Pointeur_,(_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,ADDR _Fichier_Octets_Lus_,NULL
		invoke CloseHandle,_Fichier_Pointeur_Fichier_Temporaire_		;; fermer _Fichier_Pointeur_Fichier_Temporaire_, devenu inutile maintenant

		pop ecx										;; dsempiler ecx, pour restaurer l'adresse de la structure _Pointeurs_Structure_Bitmap_
; obtenir les pointeurs pour la structure _Pointeurs_Structure_Bitmap_
		mov eax,(_Bloc_Memoire_ PTR [edi])._Pointeur_		;; placer l'adresse de dbut du fichier dans esi
		mov (_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Entete_Bitmap_,eax		;; sauvegarder le pointeur Pointeur_Entete_Bitmap
		add eax,SIZEOF BITMAPFILEHEADER					;; ajouter la longueur de l'entete
		mov (_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Informations_Bitmap_,eax		;; sauvegarder l'adresse des informations du bitmap
		add eax,SIZEOF BITMAPINFOHEADER					;; ajouter la longueur des informations
		mov (_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Palette_Bitmap_,eax		;; sauvegarder l'adresse de la palette du bitmap
		mov eax,(_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Entete_Bitmap_		;; replacer l'adresse de dbut du fichier dans eax
		add eax,(BITMAPFILEHEADER PTR [eax]).bfOffBits		;; ajouter le nombre d'octets qui spare l'adresse de l'entete du dpart des pixels
		mov (_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Pixels_Du_Bitmap_,eax		;; sauvegarder l'adresse du dpart des pixels
		mov eax,_Fichier_Octets_Lus_						;; retourne le nombre d'octets lus dans eax

;		pop ecx										;; dsempiler ecx (fait auparavant)
		pop edx										;; dsempiler edx
	ret												;; retourner (sortir de la procdure)

; cas o il n'y a rien  charger...
PasDeFichierACharger:

		pop ecx										;; dsempiler ecx (pas fait auparavant)
		pop edx										;; dsempiler edx
	ret												;; retourner (sortir de la procdure)
ChargerFichier_Bmp ENDP


ALIGN 16
;
; obtenir le rpertoire en cours d'utilisation
;
; Syntaxe :
; mov edi,{OFFSET (adresse) de la chaine qui contiendra le chemin du rpertoire}
; call ObtenirRepertoireEnCours
;
; Retourne :
; rien
;
ObtenirRepertoireEnCours PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi

		invoke GetCurrentDirectory,MAX_PATH,edi
		mov esi,OFFSET _Fichier_Chaine_Chemin_Temporaire_Ajout
		call FusionnerChainesAscii

		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
ObtenirRepertoireEnCours ENDP


ALIGN 16
;
; obtenir la taille non-dcompresse (en octets) d'un fichier
; note : la structure OPENFILENAME concernant le fichier doit avoir t mise  jour si on utilise cette structure
;
; Syntaxe :
; mov ebx,{OFFSET (adresse) de la chane contenant le chemin+nom du fichier (peut tre OPENFILENAME.lpstrFile)}
; call ObtenirTailleFichier
;
; Retourne :
; eax = la taille (non dcomprsse) du fichier, ou -1 si il y a une erreur
;
ObtenirTailleFichier PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke FindFirstFile,ebx,ADDR _Fichier_Information_Fichier_ ;; rcuprer les infos du fichier slectionn
		cmp eax,INVALID_HANDLE_VALUE						;; comparer eax  -1
		je Label02									;; si c'est gal (erreur pointeur), aller Label02
; sinon, le pointeur est valide
		invoke FindClose,eax							;; alors, supprimer le pointeur dont on n'a plus besion
		mov eax,_Fichier_Information_Fichier_.nFileSizeLow		;; et rcuprer la taille du fichier
Label02:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
ObtenirTailleFichier ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement des blocs mmoire
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_GMEE_CE_Compteur_Lignes_Ecran_			DWORD ?


.CODE
ALIGN 16
;
; allouer un bloc mmoire  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
; enfin, comme ici on alloue un bloc mmoire, il faudra le librer en fin de programme avec LibererBlocMemoire
;
; Syntaxe :
; mov eax,{taille du bloc mmoire que l'on va crer (en octets)}
; mov esi,{adresse (offset) d'une structure _Informations_Memoire_}
; mov edi,{adresse (offset) d'une structure _Bloc_Memoire_}
; call AllouerBlocMemoire
;
; Retourne :
; eax = adresse du bloc mmoire align
; et les variables de la structure _Bloc_Memoire_ sont dfinies
;
AllouerBlocMemoire PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax		;; placer eax dans x._Taille_Du_Bloc_
		add eax,000000010h								;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax		;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax		;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax		;; sauvegarder eax dans x._Pointeur_

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
AllouerBlocMemoire ENDP


ALIGN 16
;
; copier un bloc memoire vers un autre bloc memoire
; note : il faut s'assurer que les blocs mmoire ne se chevauchent pas, sinon il faut utiliser BougerBlocMemoire...
;
; Syntaxe :
; mov eax,{taille  copier en octets}
; mov esi,{adresse du bloc source}
; mov edi,{adresse du bloc de destination}
; call CopierBlocMemoire
;
; Retourne :
; rien
;
CopierBlocMemoire PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

; ici on traite les owords
		mov ecx,eax									;; copier eax dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label1										;; si ecx est gal  0, aller Label1
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
;		nop											;; )
Label0:	mov edx,DWORD PTR[esi+ecx]						;; placer le dword en esi+ecx dans ebx
		mov DWORD PTR[edi+ecx],edx						;; placer le dword en edi+ecx
		mov edx,DWORD PTR[esi+ecx+4]						;; placer le dword en esi+ecx+4 dans edx
		mov DWORD PTR[edi+ecx+4],edx						;; placer le dword en edi+ecx+4
		mov edx,DWORD PTR[esi+ecx+8]						;; placer le dword en esi+ecx+8 dans ebx
		mov DWORD PTR[edi+ecx+8],edx						;; placer le dword en edi+ecx+8
		mov edx,DWORD PTR[esi+ecx+12]						;; placer le dword en esi+ecx+12 dans edx
		mov DWORD PTR[edi+ecx+12],edx						;; placer le dword en edi+ecx+12
		add ecx,DWORD*4								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label0									;; tant que ecx est diffrent de 0, aller Label0
; ici on traite les dwords
Label1:	mov ecx,eax									;; copier eax dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label3										;; si ecx est gal  0, aller Label3
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
Label2:	mov edx,DWORD PTR [esi+ecx]						;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx						;; et le recopier en edi+ecx
		add ecx,DWORD									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label2									;; tant que ecx est sign, aller Label2
; ici on traite les octets
Label3:	mov ecx,eax									;; copier eax dans ecx
		and ecx,00000000000000000000000000000011b			;; ne conserver que les bits octets en ecx
		jz Label5										;; si ecx est gal  0, aller Label5
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
Label4:	mov dl,BYTE PTR [esi+ecx]						;; placer l'octet en esi+edx dans dl
		mov BYTE PTR [edi+ecx],dl						;; et le recopier en edi+ecx
		inc ecx										;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label4									;; tant que ecx est diffrent de 0, aller Label4
Label5:	sub esi,eax									;; soustraire la taille  esi (pour retrouver l'adresse originelle)
		sub edi,eax									;; soustraire la taille  edi (pour retrouver l'adresse originelle)

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CopierBlocMemoire ENDP


ALIGN 16
;
; copier un cran dans un autre
; note : il faut aussi s'assurer que les blocs mmoire ne se chevauchent pas, ne pas oublier de nettoyer l'cran
; au pralable si c'est ncessaire
;
; Syntaxe :
; mov esi,{OFFSET (adresse) de la structure _Bloc_Memoire_Ecran_ de l'cran originel}
; mov edi,{OFFSET (adresse) de la structure _Bloc_Memoire_Ecran_ de l'ecran de destination}
; call CopierEcran
;
; Retourne :
; rien
;
CopierEcran PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebp,edi									;; copier l'adresse de la structure destination dans ebp
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_		;; placer la largeur de l'cran destination dans eax
		cmp eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_		;; comparer cette largeur  celle de l'cran source
		jbe Label01											;; si elle est infrieure ou gale, aller Label01
		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_		;; sinon, placer la largeur de l'cran de destination dans eax
Label01:	mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_		;; placer la hauteur de l'cran source dans ebx
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Hauteur_Ecran_		;; comparer cette hauteur  celle de l'cran de destination
		jbe Label02											;; si elle est infrieure ou gale, aller Label02
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Hauteur_Ecran_		;; sinon, placer la largeur de l'cran de destination dans ebx
Label02:	mov edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_			;; placer l'adresse du dbut des pixels de destination dans edi
		mov _GMEE_CE_Compteur_Lignes_Ecran_,ebx						;; sauvegarder le compteur de lignes
		mov ebx,esi											;; et placer l'adresse de la structure source dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_			;; placer l'adresse du dbut des pixels source dans esi
; puis on copie les lignes, ici on traite les 4x owords
Label03:	mov ecx,eax									;; copier eax dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label05									;; si ecx est gal  0, aller Label05
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
Label04:	mov edx,DWORD PTR[esi+ecx]						;; placer le dword en esi+ecx dans ebx
		mov DWORD PTR[edi+ecx],edx						;; placer le dword en edi+ecx
		mov edx,DWORD PTR[esi+ecx+4]						;; placer le dword en esi+ecx+4 dans edx
		mov DWORD PTR[edi+ecx+4],edx						;; placer le dword en edi+ecx+4
		mov edx,DWORD PTR[esi+ecx+8]						;; placer le dword en esi+ecx+8 dans ebx
		mov DWORD PTR[edi+ecx+8],edx						;; placer le dword en edi+ecx+8
		mov edx,DWORD PTR[esi+ecx+12]						;; placer le dword en esi+ecx+12 dans edx
		mov DWORD PTR[edi+ecx+12],edx						;; placer le dword en edi+ecx+12
		add ecx,DWORD*4								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label04									;; tant que ecx est diffrent de 0, aller Label04
; ici on traite les dwords
Label05:	mov ecx,eax									;; copier eax dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label07									;; si ecx est gal  0, aller Label07
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
Label06:	mov edx,DWORD PTR [esi+ecx]						;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx						;; et le recopier en edi+ecx
		add ecx,DWORD									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label06									;; tant que ecx est sign, aller Label06
; ici on ne traite pas les octets, puisqu'au minimum ce sont des dwords
Label07:	sub edi,eax									;; soustraire la taille  edi (pour retrouver l'adresse originelle)
		sub esi,eax									;; soustraire la taille  esi (pour retrouver l'adresse originelle)
		add esi,(_Bloc_Memoire_Ecran_ PTR [ebx])._Largeur_Ecran_X4_		;; ajouter une ligne  l'cran source
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ajouter une ligne  l'cran de destination
		dec _GMEE_CE_Compteur_Lignes_Ecran_				;; dcrmenter la hauteur cran  copier
		jnz Label03									;; tant que ebx est diffrent de 0, aller Label03

		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
CopierEcran ENDP


ALIGN 16
;
; allouer un cran (bloc mmoire)  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
; enfin, comme ici on alloue un bloc mmoire, il faudra le librer en fin de programme avec SupprimerEcran
;
; Syntaxe :
; mov eax,{largeur de l'cran (en pixels)}
; mov ebx,{hauteur de l'cran (en pixels)}
; mov esi,{OFFSET (adresse) d'une structure _Informations_Memoire_}
; mov edi,{OFFSET (adresse) d'une structure _Bloc_Memoire_Ecran_}
; call CreerEcran
;
; Retourne :
; eax = adresse du bloc mmoire align (ce sera le tampon de l'cran)
; et les variables de la structure _Bloc_Memoire_Ecran_ sont dfinies
;
CreerEcran PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_,eax		;; placer eax dans x._Largeur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_,ebx		;; placer eax dans x._Hauteur_Ecran_
		shl eax,2										;; multiplier la largeur par 4
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_,eax		;; placer eax dans x._Largeur_Ecran_X4_
		mul ebx										;; multiplier _Largeur_Ecran_X4_ par _Hauteur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Taille_Du_Bloc_,eax		;; placer eax dans x._Taille_Du_Bloc_
		add eax,16									;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax		;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_,eax		;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_,eax		;; sauvegarder eax dans x._Pointeur_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_Dbuffer_,eax		;; sauvegarder eax dans x._Pointeur_Dbuffer_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_Zbuffer_,eax		;; sauvegarder eax dans x._Pointeur_Zbuffer_ (ca vite des dsagrments de mauvaise utilisation CreerEcran/CreerEcranAvecZBuffer)
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_LimitesFace_,eax		;; sauvegarder eax dans x._Pointeur_LimitesFace_

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CreerEcran ENDP


ALIGN 16
;
; allouer un cran (bloc mmoire)  un pointeur (ce bloc est align sur 16 octets),
; alloue galement un autre cran  un deuxime pointeur (Dbuffer, qui sert pour viter l'effet flicker)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
; note 2 : au lieu d'utiliser le pointeur cr pour Dbuffer, ajouter ou enlever la taille du bloc au pointeur
; normal sera beaucoup plus rapide que d'effectuer des tas de tests pour savoir sur quel cran on travail...
; enfin, comme ici on alloue un bloc mmoire, il faudra le librer en fin de programme avec SupprimerEcran
;
; Syntaxe :
; mov eax,{largeur de l'cran (en pixels)}
; mov ebx,{hauteur de l'cran (en pixels)}
; mov esi,{OFFSET (adresse) d'une structure _Informations_Memoire_}
; mov edi,{OFFSET (adresse) d'une structure _Bloc_Memoire_Ecran_}
; call CreerEcranAvecDBuffer
;
; Retourne :
; eax = adresse du bloc mmoire align (ce sera le tampon de l'cran)
; et les variables de la structure _Bloc_Memoire_Ecran_ sont dfinies
;
CreerEcranAvecDBuffer PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_,eax		;; placer eax dans x._Largeur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_,ebx		;; placer ebx dans x._Hauteur_Ecran_
		shl eax,2										;; multiplier la largeur par 4
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_,eax		;; placer eax dans x._Largeur_Ecran_X4_
		mul ebx										;; multiplier _Largeur_Ecran_X4_ par _Hauteur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Taille_Du_Bloc_,eax		;; placer eax dans x._Taille_Du_Bloc_
		add eax,eax									;; multiplier la taille par 2 (l'cran normal + le Dbuffer)
;		shl eax,1										;; multiplier la taille par 2 (l'cran normal + le Dbuffer) (moins rapide)
		add eax,000000010h								;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax		;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_,eax		;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_,eax		;; sauvegarder eax dans x._Pointeur_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_Zbuffer_,eax		;; sauvegarder eax dans x._Pointeur_Zbuffer_
		add eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Taille_Du_Bloc_		;; ajouter la taille cran (pour passer au deuxime)
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_Dbuffer_,eax		;; sauvegarder eax dans x._Pointeur_Dbuffer_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_LimitesFace_,eax		;; sauvegarder eax dans x._Pointeur_LimitesFace_
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_		;; placer le pointeur normal dans eax

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CreerEcranAvecDBuffer ENDP


ALIGN 16
;
; crer l'instance mmoire (ce qui doit tre fait, une fois, avant de pouvoir allouer des blocs mmoires)
; note : normalement (sauf cas exceptionnels) une seule instance suffit pour l'ensemble de votre programme
; enfin, il ne faudra pas oublier de librer l'instance en fin de programme avec SupprimerInstanceMemoire
;
; Syntaxe :
; mov esi,{adresse (offset) d'une structure _Informations_Memoire_}
; call CreerInstanceMemoire
;
; Retourne :
; eax = l'adresse de l'instance
; et les variables de la structure _Informations_Memoire_ sont dfinies
;
CreerInstanceMemoire PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapCreate,HEAP_NO_SERIALIZE,(_Informations_Memoire_ PTR [esi])._Taille_Initiale_,(_Informations_Memoire_ PTR [esi])._Taille_Maximale_		;; cr une instance mmoire, et defini des valeurs mmoire
		mov (_Informations_Memoire_ PTR [esi])._Instance_,eax		;; sauvegarde du pointeur de l'instance

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CreerInstanceMemoire ENDP


ALIGN 16
;
; mettre  jour l'cran sur lequel on va travailler (cette routine n'est utile que lorsqu'il y a un dbuffer. et
; ne devrait pas tre employe s'il n'y en a pas... mme si ca ne causera pas de crash). cette mise  jour doit
; tre positionne au dbut de la boucle principale de votre programme (ou tout au moins avant d'crire pour la
; premire fois dans l'cran), ou alors en toute fin de boucle (aprs l'utilisation de SetDIBitsToDevice)
;
; Syntaxe :
; mov edi,{OFFSET (adresse) d'une structure _Bloc_Memoire_Ecran_}
; call MiseAJourDBuffer
;
; Retourne :
; rien
;
MiseAJourDBuffer PROC

		push (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_				;; ) changer les pointeurs (c'est plus rapide que d'changer les blocs...)
		push (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_Dbuffer_		;; )
		pop (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_				;; )
		pop (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_Dbuffer_		;; )

	ret												;; retourner (sortir de la procdure)
MiseAJourDBuffer ENDP


ALIGN 16
;
; librer un bloc mmoire
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de librer l'instance mmoire en fin de programme
;
; Syntaxe :
; mov esi,{adresse (offset) d'une structure _Informations_Memoire_}
; mov edi,{adresse (offset) d'une structure _Bloc_Memoire_}
; call SupprimerBlocMemoire
;
; Retourne :
; rien
;
SupprimerBlocMemoire PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_		;; librer le bloc mmoire correspondant au pointeur

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
SupprimerBlocMemoire ENDP


ALIGN 16
;
; librer un cran (bloc mmoire)
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Syntaxe :
; mov esi,{OFFSET (adresse) d'une structure _Informations_Memoire_}
; mov edi,{OFFSET (adresse) d'une structure _Bloc_Memoire_Ecran_}
; call SupprimerEcran
;
; Retourne :
; rien
;
SupprimerEcran PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_		;; librer le bloc mmoire correspondant au pointeur

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
SupprimerEcran ENDP


ALIGN 16
;
; supprimer l'instance mmoire (ce qui doit tre fait avant de sortir de l'application, si une instance  t cre)
;
; Syntaxe :
; mov esi,{adresse (offset) d'une structure _Informations_Memoire_}
; call SupprimerInstanceMemoire
;
; Retourne :
; rien
;
SupprimerInstanceMemoire PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapDestroy,(_Informations_Memoire_ PTR [esi])._Instance_		;; librer l'instance mmoire

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
SupprimerInstanceMemoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de dessin de ligne
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Ligne_Decalage_Y_					DWORD ?,?,?,?			;; (align 16) le dcalage  pratiquer sur l'axe Y
_Ligne_Ecart_Maximal_				DWORD ?,?,?,?			;; (align 16)
_Ligne_Couleur_De_La_Ligne_			DWORD ?,?,?,?			;; (align 16) couleur de la ligne
_Ligne_Mmx_Masque_Alpha_movd_			DWORD 0FF000000h,0FF000000h,0FF000000h,0FF000000h
_Ligne_Mmx_Masque_ARVB_unpck_			DWORD 000FF00FFh,000FF00FFh,000FF00FFh,000FF00FFh


.CODE
ALIGN 16
;
; dessiner une ligne de X1,Y1  X2,Y2, quelque soit la validit des valeurs (cette version considre que tous les
; alphas de la ligne ont la mme valeur, ce qui est gnralement le cas...)
; note : ici on utilise une table multiplicatrice, pour eviter d'utiliser la trs lente instruction div pour les
; divisions. la table  t vrifie pour toutes les valeurs  diviser de 0  4095, et de 2  4095 pour les
; diviseurs (0 et 1 ne pouvant logiquement pas tre traiter par la table)
;
; Syntaxe :
; mov eax,{la coordonne X1 (position largeur en pixels)}
; mov ebx,{la coordonne Y1 (position hauteur en pixels)}
; mov ecx,{la coordonne X2 (position largeur en pixels)}
; mov edx,{la coordonne Y2 (position hauteur en pixels)}
; mov esi,{OFFSET (adresse) de la structure _Bloc_Memoire_Ecran_ de l'cran}
; mov edi,{la couleur de la ligne (format A,R,V,B)}
; call Mmx_DessinerLigne_Alpha
;
; Retourne :
; rien, (attention, tous les registres MMx sont modifis)
;
Mmx_DessinerLigne_Alpha PROC

;
; ici, on teste si les points se situent bien dans l'cran, sinon on va effectuer d'autres tests...
;
		cmp eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_		;; comparer eax  la largeur
		jae Label12									;; si c'est suprieur ou gal, aller Label12
		cmp ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_		;; comparer X2  x._Largeur_Ecran_
		jae Label12									;; si c'est suprieur ou gal, aller Label12
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_		;; comparer ebx  la hauteur
		jae Label12									;; si c'est suprieur ou gal, aller Label12
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_		;; comparer Y2  x._Hauteur_Ecran_
		jae Label12									;; si c'est suprieur ou gal, aller Label12
;ALIGN 16
;
; l, les 2 points sont situs dans l'cran, alors on fait dans la rapidit...
;
		movd MM6,edi									;; MM6 = A,R,V,B
		movd MM2,edi									;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Ligne_Mmx_Masque_Alpha_movd_		;; MM2 = A,0,0,0
		movq MM3,MM2									;; MM3 = A,0,0,0
		psrlq MM3,8									;; MM3 = 0,A,0,0
		psrlq MM2,24									;; MM2 = 0,0,0,A
		punpckldq MM2,MM2								;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3									;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2									;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Ligne_Mmx_Masque_ARVB_unpck_		;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7									;; MM7 = 0,0,0,0 , 0,0,0,0
Label00:	pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on sauvegarde la couleur (ce qui permettra d'utiliser le registre edi)
		cmp eax,ecx									;; comparer la coordonne X1  X2
		ja Label01									;; si X1 est suprieur  X2, aller Label01
; ici, eax est le plus  gauche, donc on n'change pas la position des points
		lea edi,[4*eax]								;; sauvegarder la coordonne X1 *4 dans edi
		sub ecx,eax									;; enlever X1  X2
		sub edx,ebx									;; enlever Y1  Y2
		mov ebp,edx									;; sauvegarder l'cart Y (Y2-Y1) dans ebp
		mov eax,ebx									;; placer Y1 dans eax
		mov ebx,ecx									;; placer l'cart X (X2-X1) dans ebx
		jmp Label02									;; aller Label02
; ici, ecx est le plus  gauche, donc on change la position des points (ce qui evitera les lignes "doubles" et le dcalage X sera automatiquement Positif)
Label01:	lea edi,[4*ecx]								;; sauvegarder la coordonne X1 (en fait X2) *4 dans edi
		sub eax,ecx									;; enlever X2  X1
		sub ebx,edx									;; enlever Y2  Y1
		mov ebp,ebx									;; sauvegarder l'cart Y (Y1-Y2) dans ebp
		mov ebx,eax									;; placer l'cart X (X1-X2) dans ebx
		mov eax,edx									;; placer Y1 (en fait Y2)
; ici, on defini le premier point (enfin... celui qui est le plus  gauche)
Label02:	mov ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_		;; placer x._Largeur_Ecran_X4_ dans ecx, pour obtenir un pas Y
		mul ecx										;; multiplier Y1 par x._Largeur_Ecran_X4_
		add edi,eax									;; ajouter Y1 * x._Largeur_Ecran_X4_  edi
		add edi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_		;; on ajoute  edi le pointeur de dbut du bloc mmoire (qui contient dsormais la position du point)
; ici, on dfini si le dcalage Y est ngatif ou positif
		mov eax,ebp									;; placer ebp dans eax
		test eax,eax									;; fixer les flags de eax
		jns Label03									;; si eax n'est pas sign, aller Label03
		neg eax										;; sinon, on inverse eax, pour obtenir un cart en hauteur positif
		neg ecx										;; inverser ecx (x._Largeur_Ecran_X4_), pour obtenir un pas Y ngatif
; ici, on sauvegarde le dcalage de ligne obtenu
Label03:	mov ebp,ecx									;; sauvegarder ecx dans ebp (cart Y * largeur ligne)
; ici,
; eax = cart en hauteur
; ebx = cart en largeur
; esi = adresse de la structure _Bloc_Memoire_Ecran_
; edi = adresse cran + position Y + position X

; ici, on dtermine laquelle des 2 boucles on va utiliser
		cmp eax,ebx									;; comparer eax  ebx
		ja Label07									;; si eax est suprieur, aller Label07
;
; ici, on traite le cas o la largeur est la plus importante
;
		mov ecx,ebx									;; copier ebx (l'cart en largeur) dans ecx
		test ecx,ecx									;; fixer les flags de ecx
		jz Label06									;; si ecx est gal  zro, aller Label06
		lea esi,[4*ebx]								;; placer ebx*4 dans esi, qui devient notre pas de boucle
		add edi,esi									;; ajouter esi  edi
		neg esi										;; inverser esi (qui devient notre pas de boucle)
		inc eax										;; incrmenter eax (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label04:	movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
; calcul des nouvelles coordonnes
		sub ecx,eax									;; soustraire l'cart en hauteur  ecx
		jns Label05									;; si c'est positif, aller Label05
		add ecx,ebx									;; sinon, ajouter l'cart en largeur  ecx
		add edi,ebp									;; ajouter ebp (cart Y * largeur ligne)  edi
Label05:	add esi,DWORD									;; augmenter esi de DWORD
		jnz Label04									;; tant que esi n'est pas gal  0, retourner Label04
; on place le dernier point
Label06:	movd MM0,DWORD PTR [edi]							;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi],MM0							;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
;
; ici, on traite le cas o la hauteur est la plus importante
;
Label07:	mov ecx,eax									;; copier eax (l'cart en hauteur) dans ecx
		imul ebp										;; multiplier eax par ebp (cart Y * largeur ligne) (sign car ebp peut tre ngatif)
		mov esi,eax									;; placer eax dans esi, qui va devenir notre pas de boucle
		mov eax,ecx									;; replacer l'cart en hauteur dans eax
		test ecx,ecx									;; fixer les flags de ecx
		jz Label10									;; si ecx est gal  zro, aller Label10
		add edi,esi									;; ajouter esi  edi
		neg esi										;; inverser esi (qui devient notre pas de boucle)
		inc ebx										;; incrmenter ebx (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label08:	movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
; calcul des nouvelles coordonnes
		sub ecx,ebx									;; soustraire l'cart en largeur  ecx
		jns Label09									;; si c'est positif, aller Label09
		add ecx,eax									;; sinon, ajouter l'cart en hauteur  ecx
		add edi,DWORD									;; ajouter DWORD  edi
Label09:	add esi,ebp									;; augmenter esi de ebp (cart Y * largeur ligne)
		jnz Label08									;; tant que esi n'est pas gal  0, retourner Label08
; on place le dernier point
Label10:	movd MM0,DWORD PTR [edi]							;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi],MM0							;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
Label11:
	ret												;; retourner (sortir de la procdure)


;
; ici, on va determiner s'il y a un travail  effectuer ou pas (si la ligne est compltement hors cran on sort)
;

; ici, on va effectuer une serie de test en fonction des positions X
Label12:	cmp eax,ecx									;; comparer eax  ecx
		jg Label14									;; si eax est suprieur sign, aller Label14
;
; ici, ecx >= eax
;
		bt ecx,31										;; tester le bit du signe de X2
		jc Label11									;; s'il est positionn (X1 et X2 < 0), aller Label11 (la sortie)
		cmp eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_		;; comparer X1  x._Largeur_Ecran_
		jge Label11									;; si c'est suprieure ou gale sign (X1 et X2 > largeur), aller Label11 (la sortie)
; ici, on va effectuer une serie de test en fonction des positions Y
		cmp ebx,edx									;; comparer ebx  edx
		jg Label13									;; si eax est infrieur sign, aller Label13

; ici, ecx >= eax et edx >= ebx
		bt edx,31										;; tester le bit du signe de Y2
		jc Label11									;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_		;; comparer Y1  x._Hauteur_Ecran_
		jge Label11									;; si c'est suprieure ou gale sign (Y1 et Y2 > hauteur), aller Label11 (la sortie)
; on initialise quelques valeurs
		movd MM6,edi									;; MM6 = A,R,V,B
		movd MM2,edi									;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Ligne_Mmx_Masque_Alpha_movd_		;; MM2 = A,0,0,0
		movq MM3,MM2									;; MM3 = A,0,0,0
		psrlq MM3,8									;; MM3 = 0,A,0,0
		psrlq MM2,24									;; MM2 = 0,0,0,A
		punpckldq MM2,MM2								;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3									;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2									;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Ligne_Mmx_Masque_ARVB_unpck_		;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7									;; MM7 = 0,0,0,0 , 0,0,0,0
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov ebp,esi									;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt eax,31										;; tester le bit du signe de X1
		jc Label27									;; s'il est positionn (X1 < 0), aller Label27
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_		;; comparer Y1  x._Hauteur_Ecran_
		jae Label27									;; si c'est suprieure ou gale (Y1 > 0 ou Y1 > hauteur), aller Label27
; ici, on n'change pas les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,eax									;; sauvegarder la coordonne X1 dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub ecx,eax									;; enlever X1  X2
		sub edx,ebx									;; enlever Y1  Y2
		mov _Ligne_Decalage_Y_,edx						;; sauvegarder l'cart Y (Y2-Y1) dans _Ligne_Decalage_Y_
		mov eax,ebx									;; placer Y1 dans eax
		mov ebx,ecx									;; placer l'cart X (X2-X1) dans ebx
		jmp Label16									;; aller Label16

; ici, ecx >= eax et ebx > edx
Label13:	bt ebx,31										;; tester le bit du signe de Y1
		jc Label11									;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_		;; comparer Y2  x._Hauteur_Ecran_
		jge Label11									;; si c'est suprieure ou gale sign (Y1 et Y2 > hauteur), aller Label11 (la sortie)
; on initialise quelques valeurs
		movd MM6,edi									;; MM6 = A,R,V,B
		movd MM2,edi									;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Ligne_Mmx_Masque_Alpha_movd_		;; MM2 = A,0,0,0
		movq MM3,MM2									;; MM3 = A,0,0,0
		psrlq MM3,8									;; MM3 = 0,A,0,0
		psrlq MM2,24									;; MM2 = 0,0,0,A
		punpckldq MM2,MM2								;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3									;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2									;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Ligne_Mmx_Masque_ARVB_unpck_		;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7									;; MM7 = 0,0,0,0 , 0,0,0,0
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov ebp,esi									;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt eax,31										;; tester le bit du signe de X1
		jc Label27									;; s'il est positionn (X1 < 0), aller Label27
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_		;; comparer Y1  x._Hauteur_Ecran_
		jae Label27									;; si c'est suprieure ou gale (Y1 > 0 ou Y1 > hauteur), aller Label27
; ici, on n'change pas les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,eax									;; sauvegarder la coordonne X1 dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub ecx,eax									;; enlever X1  X2
		sub edx,ebx									;; enlever Y1  Y2
		mov _Ligne_Decalage_Y_,edx						;; sauvegarder l'cart Y (Y2-Y1) dans _Ligne_Decalage_Y_
		mov eax,ebx									;; placer Y1 dans eax
		mov ebx,ecx									;; placer l'cart X (X2-X1) dans ebx
		jmp Label16									;; aller Label16

;
; ici, eax > ecx
;
Label14:	bt eax,31										;; tester le bit du signe de X1
		jc Label11									;; s'il est positionn (X1 et X2 < 0), aller Label11 (la sortie)
		cmp ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_		;; comparer X2  x._Largeur_Ecran_
		jge Label11									;; si c'est suprieure ou gale sign (X1 et X2 > largeur), aller Label11 (la sortie)
; ici, on va effectuer une serie de test en fonction des positions Y
		cmp ebx,edx									;; comparer ebx  edx
		jg Label15									;; si ebx est suprieur sign, aller Label15

; ici, edx >= ebx
		bt edx,31										;; tester le bit du signe de Y2
		jc Label11									;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_		;; comparer Y1  x._Hauteur_Ecran_
		jge Label11									;; si c'est suprieure ou gale sign (Y1 et Y2 > hauteur), aller Label11 (la sortie)
; on initialise quelques valeurs
		movd MM6,edi									;; MM6 = A,R,V,B
		movd MM2,edi									;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Ligne_Mmx_Masque_Alpha_movd_		;; MM2 = A,0,0,0
		movq MM3,MM2									;; MM3 = A,0,0,0
		psrlq MM3,8									;; MM3 = 0,A,0,0
		psrlq MM2,24									;; MM2 = 0,0,0,A
		punpckldq MM2,MM2								;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3									;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2									;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Ligne_Mmx_Masque_ARVB_unpck_		;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7									;; MM7 = 0,0,0,0 , 0,0,0,0
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov ebp,esi									;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt ecx,31										;; tester le bit du signe de X2
		jc Label27									;; s'il est positionn (X2 < 0), aller Label27
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_		;; comparer Y2  x._Hauteur_Ecran_
		jae Label27									;; si c'est suprieure ou gale (Y2 > 0 ou Y2 > hauteur), aller Label27
; ici, on change les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,ecx									;; sauvegarder la coordonne X1 (en fait X2) dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub eax,ecx									;; enlever X2  X1
		sub ebx,edx									;; enlever Y2  Y1
		mov _Ligne_Decalage_Y_,ebx						;; sauvegarder l'cart Y (Y1-Y2) dans _Ligne_Decalage_Y_
		mov ebx,eax									;; placer l'cart X (X1-X2) dans ebx
		mov eax,edx									;; placer Y1 (en fait Y2)
		jmp Label16									;; aller Label16

; ici, ebx > edx
Label15:	bt ebx,31										;; tester le bit du signe de Y1
		jc Label11									;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_		;; comparer Y2  x._Hauteur_Ecran_
		jge Label11									;; si c'est suprieure ou gale sign (Y1 et Y2 > hauteur), aller Label11 (la sortie)
; on initialise quelques valeurs
		movd MM6,edi									;; MM6 = A,R,V,B
		movd MM2,edi									;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Ligne_Mmx_Masque_Alpha_movd_		;; MM2 = A,0,0,0
		movq MM3,MM2									;; MM3 = A,0,0,0
		psrlq MM3,8									;; MM3 = 0,A,0,0
		psrlq MM2,24									;; MM2 = 0,0,0,A
		punpckldq MM2,MM2								;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3									;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2									;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Ligne_Mmx_Masque_ARVB_unpck_		;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7									;; MM7 = 0,0,0,0 , 0,0,0,0
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov ebp,esi									;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt ecx,31										;; tester le bit du signe de X2
		jc Label27									;; s'il est positionn (X2 < 0), aller Label27
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_		;; comparer Y2  x._Hauteur_Ecran_
		jae Label27									;; si c'est suprieure ou gale (Y2 > 0 ou Y2 > hauteur), aller Label27
; ici, on change les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,ecx									;; sauvegarder la coordonne X1 (en fait X2) dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub eax,ecx									;; enlever X2  X1
		sub ebx,edx									;; enlever Y2  Y1
		mov _Ligne_Decalage_Y_,ebx						;; sauvegarder l'cart Y (Y1-Y2) dans _Ligne_Decalage_Y_
		mov ebx,eax									;; placer l'cart X (X1-X2) dans ebx
		mov eax,edx									;; placer Y1 (en fait Y2)
;		jmp Label16									;; aller Label16



;
; ici, on defini le premier point (enfin... celui qui est le plus  gauche)
;
Label16:	mov ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; placer x._Largeur_Ecran_X4_ dans ecx, pour obtenir un pas Y
		mul ecx										;; multiplier eax (Y1) par x._Largeur_Ecran_X4_
		mov edi,eax									;; placer Y1 * x._Largeur_Ecran_X4_ dans edi
; ici, on dfini si le dcalage Y est ngatif ou positif
		mov eax,_Ligne_Decalage_Y_						;; placer _Ligne_Decalage_Y_ dans eax
		test eax,eax									;; fixer les flags de eax
		jns Label17									;; si eax n'est pas sign, aller Label17
		neg eax										;; sinon, on inverse eax, pour obtenir un cart en hauteur positif
		neg ecx										;; inverser ecx (x._Largeur_Ecran_X4_), pour obtenir un pas Y ngatif
; ici, on sauvegarde le dcalage de ligne obtenu
Label17:	mov _Ligne_Decalage_Y_,ecx						;; sauvegarder ecx dans _Ligne_Decalage_Y_
; ici,
; eax = cart en hauteur
; ebx = cart en largeur
; esi = position X *4
; edi = position Y * (largeur cran *4)
;

; ici, on dtermine laquelle des 2 types de boucle on va utiliser
		cmp eax,ebx									;; comparer eax  ebx
		ja Label22									;; si eax est suprieur, aller Label22


;
; ici, on traite le cas o la largeur est la plus importante
;
		mov ecx,eax									;; sauvegarder l'cart en hauteur dans ecx
		mov eax,ebx									;; placer l'cart en largeur dans eax
		lea eax,[4*eax+esi]								;; multiplier l'cart en largeur par 4 et jouter esi (position X *4)
		mov _Ligne_Ecart_Maximal_,eax						;; sauvegarder le rsultat obtenu dans _Ligne_Ecart_Maximal_
		mov eax,ecx									;; replacer l'cart en hauteur dans eax
		mov ecx,ebx									;; copier ebx (l'cart en largeur) dans ecx
		test ecx,ecx									;; fixer les flags de ecx
		jz Label20									;; si ecx est gal  zro, aller Label20
		inc eax										;; incrmenter eax (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label18:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label21									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jae Label21									;;	)
; on place la couleur
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
		sub edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,eax									;; soustraire l'cart en hauteur  ecx
		jns Label19									;; si c'est positif, aller Label19
		add ecx,ebx									;; sinon, ajouter l'cart en largeur  ecx
		add edi,_Ligne_Decalage_Y_						;; ajouter _Ligne_Decalage_Y_  edi
Label19:	add esi,DWORD									;; augmenter esi d'1 DWORD
		cmp esi,_Ligne_Ecart_Maximal_						;; comparer esi  l'cart maximal en largeur
		jne Label18									;; tant que c'est diffrent, retourner Label18
; le dernier point
Label20:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label21									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jae Label21									;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label21:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)

;
; ici, on traite le cas o la hauteur est la plus importante
;
Label22:	mov ecx,eax									;; sauvegarder l'cart en hauteur dans ecx
		imul _Ligne_Decalage_Y_							;; multiplier eax par _Ligne_Decalage_Y_ (sign car _Ligne_Decalage_Y_ peut tre ngatif)
		add eax,edi									;; ajouter edi  eax
		mov _Ligne_Ecart_Maximal_,eax						;; sauvegarder le rsultat obtenu dans _Ligne_Ecart_Maximal_
		mov eax,ecx									;; replacer l'cart en hauteur dans eax
		test ecx,ecx									;; fixer les flags de ecx
		jz Label25									;; si esi est gal  zro, aller Label25
		inc ebx										;; incrmenter ebx (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label23:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label26									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jae Label26									;;	)
; on place la couleur
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
		sub edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,ebx									;; soustraire l'cart en largeur  ecx
		jns Label24									;; si c'est positif, aller Label24
		add ecx,eax									;; sinon, ajouter l'cart en hauteur  ecx
		add esi,DWORD									;; ajouter DWORD  esi
Label24:	add edi,_Ligne_Decalage_Y_						;; augmenter edi de _Ligne_Decalage_Y_
		cmp edi,_Ligne_Ecart_Maximal_						;; comparer edi  l'cart maximal en hauteur
		jne Label23									;; tant que c'est diffrent, retourner Label23
; le dernier point
Label25:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label26									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jae Label26									;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label26:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)


;
; ici, c'est l'algorythme le plus lent, la ligne entre (ou entre et sort) dans l'cran
;
Label27:	cmp eax,ecx									;; comparer la coordonne X1  X2
		jg Label28									;; si X1 est suprieur (sign, puisque l c'est possible)  X2, aller Label28
; ici on n'change pas la position des points
		mov esi,eax									;; sauvegarder la coordonne X1 dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub ecx,eax									;; enlever X1  X2
		sub edx,ebx									;; enlever Y1  Y2
		mov _Ligne_Decalage_Y_,edx						;; sauvegarder l'cart Y (Y2-Y1) dans _Ligne_Decalage_Y_
		mov eax,ebx									;; placer Y1 dans eax
		mov ebx,ecx									;; placer l'cart X (X2-X1) dans ebx
		jmp Label29									;; aller Label29
; ici on change la position des points (ce qui evitera les lignes "doubles" et le dcalage X sera automatiquement Positif)
Label28:	mov esi,ecx									;; sauvegarder la coordonne X1 (en fait X2) dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub eax,ecx									;; enlever X2  X1
		sub ebx,edx									;; enlever Y2  Y1
		mov _Ligne_Decalage_Y_,ebx						;; sauvegarder l'cart Y (Y1-Y2) dans _Ligne_Decalage_Y_
		mov ebx,eax									;; placer l'cart X (X1-X2) dans ebx
		mov eax,edx									;; placer Y1 (en fait Y2)
; ici, on defini le premier point (enfin... celui qui est le plus  gauche)
Label29:	mov ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; placer x._Largeur_Ecran_X4_ dans ecx, pour obtenir un pas Y
		mul ecx										;; multiplier eax (Y1) par x._Largeur_Ecran_X4_
		mov edi,eax									;; placer Y1 * x._Largeur_Ecran_X4_ dans edi
; ici, on dfini si le dcalage Y est ngatif ou positif
		mov eax,_Ligne_Decalage_Y_						;; placer _Ligne_Decalage_Y_ dans eax
		test eax,eax									;; fixer les flags de eax
		jns Label30									;; si eax n'est pas sign, aller Label30
		neg eax										;; sinon, on inverse eax, pour obtenir un cart en hauteur positif
		neg ecx										;; inverser ecx (x._Largeur_Ecran_X4_), pour obtenir un pas Y ngatif
; ici, on sauvegarde le dcalage de ligne obtenu
Label30:	mov _Ligne_Decalage_Y_,ecx						;; sauvegarder ecx dans _Ligne_Decalage_Y_
; ici,
; eax = cart en hauteur
; ebx = cart en largeur
; esi = position X *4
; edi = position Y * (largeur cran *4)
;

; ici, on dtermine laquelle des 2 types de boucle on va utiliser
		cmp eax,ebx									;; comparer eax  ebx
		ja Label40									;; si eax est suprieur, aller Label40
;
; ici, on traite le cas o la largeur est la plus importante
;
		mov ecx,eax									;; sauvegarder l'cart en hauteur dans ecx
		mov eax,ebx									;; placer l'cart en largeur dans eax
		lea eax,[4*eax+esi]								;; multiplier l'cart en largeur par 4 et jouter esi (position X *4)
		mov _Ligne_Ecart_Maximal_,eax						;; sauvegarder le rsultat obtenu dans _Ligne_Ecart_Maximal_
		mov eax,ecx									;; replacer l'cart en hauteur dans eax
		mov ecx,ebx									;; copier ebx (l'cart en largeur) dans ecx
		test ecx,ecx									;; fixer les flags de ecx
		jz Label34									;; si ecx est gal  zro, aller Label34
		inc eax										;; incrmenter eax (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label31:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label32									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jb Label37									;;	)
; ici, on calcul les prochaines coordonnes
Label32:	sub ecx,eax									;; soustraire l'cart en hauteur  ecx
		jns Label33									;; si c'est positif, aller Label33
		add ecx,ebx									;; sinon, ajouter l'cart en largeur  ecx
		add edi,_Ligne_Decalage_Y_						;; ajouter _Ligne_Decalage_Y_  edi
Label33:	add esi,DWORD									;; augmenter esi d'1 DWORD
		cmp esi,_Ligne_Ecart_Maximal_						;; comparer esi  l'cart maximal en largeur
		jne Label31									;; tant que c'est diffrent, retourner Label31
; le dernier point
Label34:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label35									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jae Label35									;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label35:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)


; ici, le point le plus  gauche est dfini alors on trace ce qui reste de la ligne
;ALIGN 16
; dbut de la boucle
Label36:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label39									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jae Label39									;;	)
Label37:	add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
		sub edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,eax									;; soustraire l'cart en hauteur  ecx
		jns Label38									;; si c'est positif, aller Label38
		add ecx,ebx									;; sinon, ajouter l'cart en largeur  ecx
		add edi,_Ligne_Decalage_Y_						;; ajouter _Ligne_Decalage_Y_  edi
Label38:	add esi,DWORD									;; augmenter esi d'1 DWORD
		cmp esi,_Ligne_Ecart_Maximal_						;; comparer esi  l'cart maximal en largeur
		jne Label36									;; tant que c'est diffrent, retourner Label36
; le dernier point
		cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label39									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jae Label39									;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label39:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)


;
; ici, on traite le cas o la hauteur est la plus importante
;
Label40:	mov ecx,eax									;; sauvegarder l'cart en hauteur dans ecx
		imul _Ligne_Decalage_Y_							;; multiplier eax par _Ligne_Decalage_Y_ (sign car _Ligne_Decalage_Y_ peut tre ngatif)
		add eax,edi									;; ajouter edi  eax
		mov _Ligne_Ecart_Maximal_,eax						;; sauvegarder le rsultat obtenu dans _Ligne_Ecart_Maximal_
		mov eax,ecx									;; replacer l'cart en hauteur dans eax
		test ecx,ecx									;; fixer les flags de ecx
		jz Label44									;; si esi est gal  zro, aller Label44
		inc ebx										;; incrmenter ebx (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label41:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label42									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jb Label47									;;	)
; ici, on calcul les prochaines coordonnes
Label42:	sub ecx,ebx									;; soustraire l'cart en largeur  ecx
		jns Label43									;; si c'est positif, aller Label43
		add ecx,eax									;; sinon, ajouter l'cart en hauteur  ecx
		add esi,DWORD									;; ajouter DWORD  esi
Label43:	add edi,_Ligne_Decalage_Y_						;; augmenter edi de _Ligne_Decalage_Y_
		cmp edi,_Ligne_Ecart_Maximal_						;; comparer edi  l'cart maximal en hauteur
		jne Label41									;; tant que c'est diffrent, retourner Label41
; le dernier point
Label44:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label45									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jae Label45									;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label45:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)


; ici, le point le plus  gauche est dfini alors on trace ce qui reste de la ligne
;ALIGN 16
; dbut de la boucle
Label46:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label49									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jae Label49									;;	)
Label47:	add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
		sub edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,ebx									;; soustraire l'cart en largeur  ecx
		jns Label48									;; si c'est positif, aller Label48
		add ecx,eax									;; sinon, ajouter l'cart en hauteur  ecx
		add esi,DWORD									;; ajouter DWORD  esi
Label48:	add edi,_Ligne_Decalage_Y_						;; augmenter edi de _Ligne_Decalage_Y_
		cmp edi,_Ligne_Ecart_Maximal_						;; comparer edi  l'cart maximal en hauteur
		jne Label46									;; tant que c'est diffrent, retourner Label46
; le dernier point
		cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_		;; ) test de prsence cran X
		jae Label49									;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_		;;	) test de prsence cran Y
		jae Label49									;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6									;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label49:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
Mmx_DessinerLigne_Alpha ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement de chaines de caractres graphiques
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_TCA_Compteur_Chaines_Temporaire_		DWORD ?


.CODE
ALIGN 16
;
; convertir un dword en texte au format dcimale (routine la plus stable pour le travail)
;
; syntaxe :
; mov eax,{la valeur  convertir en chane}
; mov esi,{adresse (offset) de la chaine de caractres  crer}
; call ConvertirValeurEnChaineDecimale
;
;
; Retourne :
; rien
;
ConvertirValeurEnChaineDecimale PROC
		push eax										;; empiler eax
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov ecx,eax									;; copier eax dans ecx
; on va diviser eax par 100000 de manire optimise
		mov edx,2814749768								;; placer 2814749768 (remplacement de 2814749767 et eax+1) dans edx
		mul edx										;; multiplier eax par 2814749768
		shr edx,16									;; dcaler edx de 16 bits  droite
		mov eax,100000									;; placer 100000 dans eax
		mov ebx,edx									;; copier edx dans ebx
		mul edx										;; multiplier edx par 100000
		sub ecx,eax									;; soustraire le rsultat en eax  ecx
		test ebx,ebx									;; fixer les flags de ebx
		mov edx,ebx									;; replacer ebx dans edx
		mov ebx,10									;; placer 10 (notre multiplicateur dcimale) dans ebx
		jz Label01									;; si c'est gal  0, aller Label01
; sinon, on traite la partie suprieure du nombre
		mov eax,429497									;; on remplace eax par 429497
		mul edx										;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label10									;; s'il existe un dpassement, aller Label10
		mul ebx										;; multiplier eax par 10
		jc Label09									;; s'il existe un dpassement, aller Label09
		mul ebx										;; multiplier eax par 10
		jc Label08									;; s'il existe un dpassement, aller Label08
		mul ebx										;; multiplier eax par 10
		jc Label07									;; s'il existe un dpassement, aller Label07
		mul ebx										;; multiplier eax par 10
		jc Label06									;; s'il existe un dpassement, aller Label06
; ici, on traite la partie infrieure du nombre
Label01:	mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label05									;; s'il existe un dpassement, aller Label05
		mul ebx										;; multiplier eax par 10
		jc Label04									;; s'il existe un dpassement, aller Label04
		mul ebx										;; multiplier eax par 10
		jc Label03									;; s'il existe un dpassement, aller Label03
		mul ebx										;; multiplier eax par 10
		jc Label02									;; s'il existe un dpassement, aller Label02
		mul ebx										;; multiplier eax par 10
; ici, on va placer X et le zro final
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XX et le zro final
Label02:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+1],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXX et le zro final
Label03:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+2],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXX et le zro final
Label04:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+3],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXX et le zro final
Label05:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+4],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXXX et le zro final
Label06:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+5],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXXXX et le zro final
Label07:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+6],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXXXXX et le zro final
Label08:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+7],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXXXXXX et le zro final
Label09:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+7],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+8],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va placer XXXXXXXXXX et le zro final
Label10:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; placer l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+7],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+8],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+9],dx							;; placer l'octet en dl et le 0 final en dh  l'adresse en esi

Label11:	pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
ConvertirValeurEnChaineDecimale ENDP


ALIGN 16
;
; copier une chane de caractres dans une autre chane
; note : videment, les tailles doivent tre valides pour les chanes source et destination
;
; Syntaxe :
; mov esi,{adresse (offset) de la chane source}
; mov edi,{adresse (offset) dans la chane de destination}
; syntaxe : CopierChaineAscii
;
; Retourne :
; eax = nombre de caractres copis (c-a-d la taille ajoute  la chane)
;
CopierChaineAscii PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label2									;; aller Label2
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
Label1:	add edx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],edx						;; placer cette valeur  l'adresse de destination
		add eax,4										;; incrmenter esi (l'adresse) de 4 (un dword)
Label2:	mov ecx,DWORD PTR [esi+eax]						;; placer le dword de l'adresse actuelle dans eax
		lea edx,[ecx-01010101h]							;; placer eax (- 1  chaque octets du dword) dans edx
		xor ecx,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and ecx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and ecx,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		add edx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de ecx
		mov [edi+eax],dl								;; placer dl  l'adresse en edi+eax
		test dl,dl									;; fixer les flags de dl
		jz Label5										;; si c'est gal  0, aller Label5
		mov [edi+eax+1],dh								;; placer dh  l'adresse en edi+eax+1
		test dh,dh									;; fixer les flags de dh
		jz Label4										;; si c'est gal  0, aller Label4
		shr edx,16									;; dcaler edx  droite de 16 bits
		mov [edi+eax+2],dl								;; placer dl  l'adresse en edi+eax+2
		test dl,dl									;; fixer les flags de dl
		jz Label3										;; si c'est gal  0, aller Label3
		mov [edi+eax+3],dh								;; placer dh  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax ) (optionnel) pour obtenir la taille de la chaine dans eax
Label3:	inc eax										;; ajouter 1  eax )
Label4:	inc eax										;; ajouter 1  eax )
Label5:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CopierChaineAscii ENDP


ALIGN 16
;
; fusionner des chaines de caractres
; note : c'est plus rapide si edi pointe exactement  l'emplacement o on ajoutera la chane, mais dans ce cas l,
; eax retournera uniquement la taille de la chane ajoute
;
; Syntaxe :
; mov esi,{adresse (offset) de la chane source que l'on ajoutera}
; mov edi,{adresse (offset) de/dans la chane de destination}
; call FusionnerChainesAscii
;
; Retourne :
; eax = la taille de la chaine ou la taille de la chaine ajoute (suivant que edi contenait l'adresse de dpart ou l'adresse de fin de la chaine de destination)
;
FusionnerChainesAscii PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push edi										;; empiler edi

; premirement on va trouver le zro final de la chaine de destination
Label1:	mov eax,DWORD PTR [edi]							;; placer le dword de l'adresse actuelle dans eax
		add edi,4										;; incrmenter edi (l'adresse) de 4 (un dword)
		lea edx,[eax-01010101h]							;; placer eax (- 1  chaque octets du dword) dans edx
		xor eax,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and eax,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and eax,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		bsf edx,eax									;; sinon, scanner le premier bit arm en eax, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4										;; soustraire 4 au numro du bit obtenu
		shr edx,3										;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea edi,[edi+edx-4]								;; placer edi + edx - 1 dword dans edi
; et on effectue la copie
		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label3									;; aller Label3
Label2:	add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],ecx						;; placer cette valeur  l'adresse de destination
		add eax,4										;; incrmenter esi (l'adresse) de 4 (un dword)
;		nop											;; ) aucun alignement ncessaire pour un meilleur rendement
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
Label3:	mov edx,DWORD PTR [esi+eax]						;; placer le dword de l'adresse actuelle dans eax
		lea ecx,[edx-01010101h]							;; placer eax (- 1  chaque octets du dword) dans ecx
		xor edx,ecx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans ecx comme masque
		and edx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label2										;; si le filtrage est gal  0, aller Label2
		and edx,ecx									;; ne conserver en eax que les bits positionns en ecx
		jz Label2										;; si le filtrage est gal  0, aller Label2
		add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de edx
		mov [edi+eax],cl								;; placer cl  l'adresse en edi+eax
		test cl,cl									;; fixer les flags de cl
		jz Label6										;; si c'est gal  0, aller Label5
		mov [edi+eax+1],ch								;; placer ch  l'adresse en edi+eax+1
		test ch,ch									;; fixer les flags de ch
		jz Label5										;; si c'est gal  0, aller Label4
		shr ecx,16									;; dcaler ecx  droite de 16 bits
		mov [edi+eax+2],cl								;; placer cl  l'adresse en edi+eax+2
		test cl,cl									;; fixer les flags de cl
		jz Label4										;; si c'est gal  0, aller Label3
		mov [edi+eax+3],ch								;; placer ch  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax ) (optionnel) pour obtenir la taille de la chaine dans eax
Label4:	inc eax										;; ajouter 1  eax )
Label5:	inc eax										;; ajouter 1  eax )
Label6:	add eax,edi									;; ajouter edi  eax

		pop edi										;; dsempiler edi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		sub eax,edi									;; et on soustrait l'adresse originelle  eax pour obtenir la nouvelle taille de la chane
	ret												;; retourner (sortir de la procdure)
FusionnerChainesAscii ENDP


ALIGN 16
;
; fusionner des chaines de caractres
; note : c'est plus rapide si edi pointe exactement  l'emplacement o on ajoutera la chane, mais dans ce cas l,
; eax retournera uniquement la taille des chanes ajoutes
;
; Syntaxe :
; mov eax,{nombre de chaines  ajouter (1 au minimum) (qui servira de compteur)}
; mov edi,{adresse (offset) de/dans la chane de destination}
; invoke FusionnerMultiplesChainesAscii [adresse de la chane source1],[adresse de la chane source2],...
;
; Retourne :
; eax = la taille de la chaine ou la taille des chanes ajoutes (suivant que edi contenait l'adresse de dpart ou l'adresse de fin de la chaine de destination)
;
FusionnerMultiplesChainesAscii PROC C _Adresse_Sources_:VARARG
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi
		push edi										;; empiler edi

		shl eax,2										;; multiplier le nombre de souces par 4
		mov _TCA_Compteur_Chaines_Temporaire_,eax			;; sauvegarder le rsultat
		xor ebx,ebx									;; effacer ebx (qui sera notre valeur de dcalage pour passer  l'adresse chane suivante)
; premirement on va trouver le zro final de la chaine de destination
Label1:	mov eax,DWORD PTR [edi]							;; placer le dword de l'adresse actuelle dans eax
		add edi,4										;; incrmenter edi (l'adresse) de 4 (un dword)
		lea edx,[eax-01010101h]							;; placer eax (- 1  chaque octets du dword) dans edx
		xor eax,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and eax,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and eax,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		bsf edx,eax									;; sinon, scanner le premier bit arm en eax, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4										;; soustraire 4 au numro du bit obtenu
		shr edx,3										;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea edi,[edi+edx-4]								;; placer edi + edx - 1 dword dans edi
; ensuite on va prparer nos copie de chaines
Label2:	mov esi,DWORD PTR [_Adresse_Sources_+ebx]			;; placer l'adresse de la nouvelle source dans esi
		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label4									;; aller Label4
;		nop											;; ) aucun alignement ncessaire pour un meilleur rendement
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
; et on effectue nos copies
Label3:	add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],ecx						;; placer cette valeur  l'adresse de destination
		add eax,4										;; incrmenter eax (notre compteur d'octets) de 4 (un dword)
Label4:	mov edx,DWORD PTR [esi+eax]						;; placer le dword de l'adresse actuelle dans edx
		lea ecx,[edx-01010101h]							;; placer eax (- 1  chaque octets du dword) dans ecx
		xor edx,ecx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans ecx comme masque
		and edx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label3										;; si le filtrage est gal  0, aller Label3
		and edx,ecx									;; ne conserver en edx que les bits positionns en ecx
		jz Label3										;; si le filtrage est gal  0, aller Label3
		add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de edx
		mov [edi+eax],cl								;; placer cl  l'adresse en edi+eax
		test cl,cl									;; fixer les flags de cl
		jz Label7										;; si c'est gal  0, aller Label7
		mov [edi+eax+1],ch								;; placer ch  l'adresse en edi+eax+1
		test ch,ch									;; fixer les flags de ch
		jz Label6										;; si c'est gal  0, aller Label6
		shr ecx,16									;; dcaler ecx  droite de 16 bits
		mov [edi+eax+2],cl								;; placer cl  l'adresse en edi+eax+2
		test cl,cl									;; fixer les flags de cl
		jz Label5										;; si c'est gal  0, aller Label5
		mov [edi+eax+3],ch								;; placer ch  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax
Label5:	inc eax										;; ajouter 1  eax
Label6:	inc eax										;; ajouter 1  eax
Label7:	lea edi,[edi+eax]								;; ajouter eax+1  edi
; l on va tester s'il y a une autre source  ajouter
		add ebx,DWORD									;; augmenter le comteur de sources d'1 dword
		cmp ebx,_TCA_Compteur_Chaines_Temporaire_			;; comparer ebx aux nombre de sources *4
		jne Label2									;; tant que c'est diffrent, aller Label2
; ici, on calcul la nouvelle taille de la chane...
		mov eax,edi									;; placer edi dans eax

		pop edi										;; dsempiler edi
		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
		sub eax,edi									;; et soustraire AdresseDestination  eax pour obtenir la nouvelle taille de la chane
	ret												;; retourner (sortir de la procdure)
FusionnerMultiplesChainesAscii ENDP


ALIGN 16
;
; obtenir la taille relle d'une chane de caractres
;
; Syntaxe :
; mov esi,{adresse (offset) de la chane dont on veut obtenir la taille}
; call ObtenirTailleChaineAscii
;
; Retourne :
; eax = taille relle de la chane
;
ObtenirTailleChaineAscii PROC
		push ebx										;; empiler ebx
		push edx										;; empiler edx

		xor eax,eax									;; effacer eax (qui sera notre compteur)
;		nop											;; ) aucun alignement ncessaire pour un meilleur rendement
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
;		nop											;; )
Label1:	mov ebx,DWORD PTR [esi+eax]						;; placer le dword de l'adresse actuelle dans ebx
		add eax,DWORD									;; incrmenter eax (le compteur) de 4 (un dword)
		lea edx,[ebx-01010101h]							;; placer ebx (- 1  chaque octets) dans edx
		xor ebx,edx									;; inverser les bits en ebx, en utilisant le rsultat obtenu dans edx comme masque
		and ebx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en ebx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and ebx,edx									;; ne conserver en ebx que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		bsf edx,ebx									;; sinon, scanner le premier bit arm en ebx, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4										;; soustraire 4 au numro du bit obtenu
		shr edx,3										;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea eax,[eax+edx-DWORD]							;; placer eax + edx - 1 dword dans eax

		pop edx										;; dsempiler edx
		pop ebx										;; dsempiler ebx
	ret												;; retourner (sortir de la procdure)
ObtenirTailleChaineAscii ENDP


