;
; squellette programme outil
;

;
; Directives de l'assembleur
;
.686P													;; minimum = pentium pro (ou 2) avec le mode privilegi
.MMX														;; pour activer les instructions mmx
.XMM														;; pour activer les instructions sse,sse2 (donc l pentium 3 minimum)
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED												;; les labels locaux sont autoriss, et les labels globaux  l'intrieur des procdures doivent tre dfinis avec 2 fois 2 points (LABEL::)
OPTION LJMP												;; lors de la compilation, le compileur prviendra si un jmp pourra tre court (SHORT)
OPTION CASEMAP:NONE											;; optionel: rends les identifiants sensibles  la casse de caractres


;
; Fichiers INCLUDE
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \Masm32\INCLUDE\user32.inc
INCLUDE \Masm32\INCLUDE\gdi32.inc
INCLUDE \Masm32\INCLUDE\Comctl32.inc
;INCLUDE \Masm32\INCLUDE\comdlg32.inc
;INCLUDE \Masm32\INCLUDE\ole32.inc
;INCLUDE \Masm32\INCLUDE\oleaut32.inc
;INCLUDE \Masm32\INCLUDE\winmm.inc
;INCLUDE \Masm32\INCLUDE\shell32.inc
;INCLUDE \MAsm32\INCLUDE\masm32.inc
;INCLUDE \Masm32\INCLUDE\ .inc


;
; Fichiers LIBRAIRIES
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \Masm32\LIB\gdi32.lib
INCLUDELIB \Masm32\LIB\Comctl32.lib
;INCLUDELIB \Masm32\LIB\comdlg32.lib
;INCLUDELIB \Masm32\LIB\ole32.lib
;INCLUDELIB \Masm32\LIB\oleaut32.lib
;INCLUDELIB \Masm32\LIB\winmm.lib
;INCLUDELIB \Masm32\LIB\shell32.lib
;INCLUDELIB \MAsm32\LIB\masm32.lib
;INCLUDELIB \Masm32\LIB\ .lib


;
; Equivalences
;

; identifiants ressources
Rsrc_IDI_Icone_32				equ 532

;Rsrc_IDB_Repertoire_16			equ 600
;Rsrc_IDB_RepertoireEtendu_16		equ 601
;Rsrc_IDB_Donnee_16				equ 602
;Rsrc_IDB_Masque_Repertoire_16		equ 603
;Rsrc_IDB_Masque_RepertoireEtendu_16	equ 604
;Rsrc_IDB_Masque_Donnee_16		equ 605

Rsrc_IDD_Horloge_Fenetre			equ 1000

Rsrc_IDD_Insuffisant			equ 2100
Rsrc_IDC_Insuffisant_C			equ 2101
Rsrc_IDC_Desole				equ 2102
Rsrc_IDC_Temps_Changer			equ 2103

Rsrc_IDD_Quitter				equ 2200
Rsrc_IDC_Quitter_C				equ 2201
Rsrc_IDC_Vraiment_quitter		equ 2202
Rsrc_IDC_Hum_Oui				equ 2203
Rsrc_IDC_Ah_Ca_Non				equ 2204


;
; Prototypes
;
GestionnaireMessagesBoiteDialoguePrincipale	PROTO :DWORD,:DWORD,:DWORD,:DWORD
GestionnaireMessagesBoitesDialogue			PROTO :DWORD,:DWORD,:DWORD,:DWORD


.DATA
;
; Definition des STRUCTURES
;

; structure pour la cration/la suppression d'une l'instance mmoire
_Informations_Memoire_	STRUCT								;; pour un total de 16 octets
	_Instance_			DWORD ?							;; (align 16) pointeur de l'instance
	_Taille_Initiale_		DWORD ?							;; taille initiale (dfinie par HeapCreate)
	_Taille_Maximale_		DWORD ?							;; taille maximale (dfinie par HeapCreate)
	_Inutilise_01_			DWORD ?							;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Informations_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire
_Bloc_Memoire_	STRUCT										;; pour un total de 16 octets
	_Taille_Du_Bloc_		DWORD ?							;; (align 16) taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Pointeur_A_Liberer_	DWORD ?							;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_			DWORD ?							;; (align 8) pointeur de la zone utilisable (align sur 16 octets)
	_Inutilise_01_			DWORD ?							;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Bloc_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire spcifique aux crans
_Bloc_Memoire_Ecran_	STRUCT								;; pour un total de 64 octets
	_Largeur_Ecran_X4_		DWORD ?							;; (align 16) largeur de l'cran relle multiplie par 4 (*DWORD) (ajout, parceque souvent utilis, evite donc des shl,2)
	_Largeur_Ecran_		DWORD ?							;; largeur de l'cran (en pixels)
	_Hauteur_Ecran_		DWORD ?							;; (align 8) hauteur de l'cran (en pixels)
	_inutilise_01_			DWORD ?							;; inutilis...
	_Taille_Du_Bloc_		DWORD ?							;; (align 16) taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_inutilise_02_			DWORD ?							;; inutilis...
	_Pointeur_			DWORD ?							;; (align 8) pointeur de la zone utilisable (adresse aligne sur 16 octets)
	_Pointeur_A_Liberer_	DWORD ?							;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_LimitesFace_	DWORD ?							;; (align 16) pointeur de la zone limites face (zro quand ce n'est pas un cran double)
	_Pointeur_Dbuffer_		DWORD ?							;; pointeur de la zone Dbuffer (quand c'est un cran double, sinon, c'est une copie du pointeur)
	_Pointeur_Zbuffer_		DWORD ?							;; (align 8) pointeur de la zone Zbuffer (quand c'est un cran double, sinon, c'est une copie du pointeur)
	_Temoins_Ecran_		DWORD ?							;; tmoins de l'cran... bit 0=cran double buffet utilis
_Bloc_Memoire_Ecran_	ENDS

; structure pour obtenir les pointeurs relatifs  un fichier bitmap charg dans un bloc mmoire
_Pointeurs_Structure_Bitmap_	STRUCT							;; pour un totals de 16 octets
	_Pointeur_Entete_Bitmap_			DWORD ?					;; position de dbut du fichier bitmap en mmoire (BITMAPFILEHEADER)
	_Pointeur_Informations_Bitmap_	DWORD ?					;; position o se situent les informations relatives au bitmap (BITMAPINFOHEADER ou BITMAPCOREHEADER)
	_Pointeur_Palette_Bitmap_		DWORD ?					;; position o se situe la palette du bitmap
	_Pointeur_Pixels_Du_Bitmap_		DWORD ?					;; position o se situe les pixels du bitmap
_Pointeurs_Structure_Bitmap_	ENDS


.DATA
ALIGN 16
;
; CONSTANTES et VARIABLES
;

Pointeur_Ligne_Commandes			DWORD ?
Instance_Application			DWORD ?
Instance_Boite_Dialogue_Principale	DWORD ?
Instance_Boites_Dialogue			DWORD ?
Pointeur_Temporaire				DWORD ?
;Pointeur_Arborescence			DWORD ?

Temoins_Boites_De_Dialogue		DWORD ?
Temoin_Poursuite_Processus		DWORD ?
Temoins_Activations				DWORD 011100b

Horloge_Pointeur_DC_Fenetre		DWORD ?

Horloge_Pointeur_Temporaire		DWORD ?
Horloge_Pointeur_DC_Temporaire	DWORD ?
Horloge_Pointeur_DC_Compatible	DWORD ?
Horloge_Pointeur_Nouveau_Dib		DWORD ?
Horloge_Pointeur_Pixels_Recuperes	DWORD ?
Horloge_Largeur_Bitmap_En_Pixels	DWORD ?
Horloge_Hauteur_Bitmap_En_Pixels	DWORD ?

Horloge_Temoin_Secondes			DWORD ?
Horloge_Temoin_Jours			DWORD ?
Horloge_Temoin_Mois				DWORD ?
Horloge_Temoin_Annees			DWORD ?
Horloge_Temoins_Touches			DWORD ?						;; bit0=LMB, bit1=MMB, bit2=RMB, bit3=1, bit4=2, bit5=S

Horloge_Largeur_Axe_Rotation		DWORD 64
Horloge_Hauteur_Axe_Rotation		DWORD 64
Horloge_Longueur_Aiguille_Secondes		DWORD 64-12
Horloge_Longueur_Aiguille_Minutes		DWORD 64-14
Horloge_Longueur_Aiguille_Heures		DWORD 64-36


Horloge_Chaine_Chemin_Et_Nom_Fichier	BYTE MAX_PATH dup (?)		;; MAX_PATH = 260
Horloge_Chaine_Titre_Fenetre			BYTE 12 DUP (0)			;; MAX_PATH = 260
Horloge_Chaine_Nom_Fichier			BYTE "Horloge.bmp",0
Horloge_Chaine_Filtre_De_Selection_Fichiers_Images	BYTE "Images (*.bmp,*.dib,*.gif,*.jpg,*.raw)",0,"*.bmp;*.dib;*.gif;*.jpg;*.raw",0,"Tous fichiers (*.*)",0,"*.*",0,0
Horloge_Chaine_Extension_Image_Par_Defaut			BYTE "bmp",0

Horloge_Temoin_Bmp_En_Memoire			BYTE 0
Chaine_Display					BYTE "DISPLAY",0


ALIGN 16
; variables structures
Instance_Memoire				_Informations_Memoire_ <?>
Horloge_Tampon_Image_Fond		_Bloc_Memoire_Ecran_ <?>
Horloge_Tampon_Ecran_Final		_Bloc_Memoire_Ecran_ <?>
Horloge_Tampon_Bitmap_Charge		_Bloc_Memoire_ <?>

Horloge_Pointeurs_Bitmap_Charge	_Pointeurs_Structure_Bitmap_ <?>

Horloge_Taille_Fenetre			RECT <?>					;; 4 Dwords (x,y du coin suprieur gauche et x,y du coin infrieur droit)
Horloge_Coordonnees_Fenetre		RECT <?>					;; 4 Dwords (x,y du coin suprieur gauche et x,y du coin infrieur droit)

Informations_Messages_OS			MSG <?>					;; 5 Dwords + 2 Words
;Informations_Fenetre			WNDCLASSEX <?>				;; 12 Dwords
; note : la structure BITMAPINFO est dcompose, parcequ'il semble qu'il y ai des difficults pour assembler
; du code lorsque la premire valeur d'une structure est une autre structure...
Horloge_Informations_Bitmap			BITMAPINFOHEADER <?>	;; ) bmiHeader (BITMAPINFOHEADER) (3 Dwords + 2 Words + 6 Dwords) + bmiColors (RGBQUAD) (4 octets)
Horloge_Informations_Bitmap_Suite_1	RGBQUAD <?>			;; )

Horloge_Entete_Informations_Bitmap		BITMAPINFOHEADER <?>	;; ) bmiHeader (BITMAPINFOHEADER) (3 Dwords + 2 Words + 6 Dwords) + bmiColors (RGBQUAD) (4 octets)
Horloge_Entete_Informations_Bitmap_Suite_1	RGBQUAD <?>		;; )


;
Table_positions_Minutes	DWORD 63,64,65,64,64,64,64,13
					DWORD 63,64,65,64,64,64,70,13
					DWORD 63,64,65,64,64,64,76,14
					DWORD 63,64,65,64,64,64,81,15
					DWORD 63,64,65,64,64,64,86,17
					DWORD 63,64,64,65,64,64,91,20
					DWORD 63,64,64,65,64,64,95,23
					DWORD 63,64,64,65,64,64,99,26
					DWORD 63,64,64,65,64,64,102,29
					DWORD 63,64,64,65,64,64,105,33
					DWORD 63,64,64,65,64,64,108,37
					DWORD 64,63,64,65,64,64,111,42
					DWORD 64,63,64,65,64,64,113,47
					DWORD 64,63,64,65,64,64,114,52
					DWORD 64,63,64,65,64,64,115,58

					DWORD 64,63,64,65,64,64,115,64
					DWORD 64,63,64,65,64,64,115,70
					DWORD 64,63,64,65,64,64,114,76
					DWORD 64,63,64,65,64,64,113,81
					DWORD 64,63,64,65,64,64,111,86
					DWORD 63,64,64,63,64,64,108,91
					DWORD 63,64,64,63,64,64,105,95
					DWORD 63,64,64,63,64,64,102,99
					DWORD 63,64,64,63,64,64,99,102
					DWORD 63,64,64,63,64,64,95,105
					DWORD 63,64,64,63,64,64,91,108
					DWORD 63,64,65,64,64,64,86,111
					DWORD 63,64,65,64,64,64,81,113
					DWORD 63,64,65,64,64,64,76,114
					DWORD 63,64,65,64,64,64,70,115

					DWORD 63,64,65,64,64,64,64,115
					DWORD 63,64,65,64,64,64,58,115
					DWORD 63,64,65,64,64,64,52,114
					DWORD 63,64,65,64,64,64,47,113
					DWORD 63,64,65,64,64,64,42,111
					DWORD 64,63,65,64,64,64,37,108
					DWORD 64,63,65,64,64,64,33,105
					DWORD 64,63,65,64,64,64,29,102
					DWORD 64,63,65,64,64,64,26,99
					DWORD 64,63,65,64,64,64,23,95
					DWORD 64,63,65,64,64,64,20,91
					DWORD 64,63,64,65,64,64,17,86
					DWORD 64,63,64,65,64,64,15,81
					DWORD 64,63,64,65,64,64,14,76
					DWORD 64,63,64,65,64,64,13,70

					DWORD 64,63,64,65,64,64,13,64
					DWORD 64,63,64,65,64,64,13,58
					DWORD 64,63,64,65,64,64,14,52
					DWORD 64,63,64,65,64,64,15,47
					DWORD 64,63,64,65,64,64,17,42
					DWORD 65,64,64,65,64,64,20,37
					DWORD 65,64,64,65,64,64,23,33
					DWORD 65,64,64,65,64,64,26,29
					DWORD 65,64,64,65,64,64,29,26
					DWORD 65,64,64,65,64,64,33,23
					DWORD 65,64,64,65,64,64,37,20
					DWORD 63,64,65,64,64,64,42,17
					DWORD 63,64,65,64,64,64,47,15
					DWORD 63,64,65,64,64,64,52,14
					DWORD 63,64,65,64,64,64,58,13

;
Table_positions_Heures	DWORD 63,64,65,64,64,64,64,28
					DWORD 63,64,65,64,64,64,68,28
					DWORD 63,64,65,64,64,64,73,29
					DWORD 63,64,65,64,64,64,76,30
					DWORD 63,64,65,64,64,64,80,31
					DWORD 63,64,64,65,64,64,83,33
					DWORD 63,64,64,65,64,64,86,35
					DWORD 63,64,64,65,64,64,88,37
					DWORD 63,64,64,65,64,64,91,40
					DWORD 63,64,64,65,64,64,93,42
					DWORD 63,64,64,65,64,64,95,45
					DWORD 64,63,64,65,64,64,97,48
					DWORD 64,63,64,65,64,64,98,52
					DWORD 64,63,64,65,64,64,99,55
					DWORD 64,63,64,65,64,64,100,60

					DWORD 64,63,64,65,64,64,100,64
					DWORD 64,63,64,65,64,64,100,68
					DWORD 64,63,64,65,64,64,99,73
					DWORD 64,63,64,65,64,64,98,76
					DWORD 64,63,64,65,64,64,97,80
					DWORD 63,64,64,63,64,64,95,83
					DWORD 63,64,64,63,64,64,93,86
					DWORD 63,64,64,63,64,64,91,88
					DWORD 63,64,64,63,64,64,88,91
					DWORD 63,64,64,63,64,64,86,93
					DWORD 63,64,64,63,64,64,83,95
					DWORD 63,64,65,64,64,64,80,97
					DWORD 63,64,65,64,64,64,76,98
					DWORD 63,64,65,64,64,64,73,99
					DWORD 63,64,65,64,64,64,68,100

					DWORD 63,64,65,64,64,64,64,100
					DWORD 63,64,65,64,64,64,60,100
					DWORD 63,64,65,64,64,64,55,99
					DWORD 63,64,65,64,64,64,52,98
					DWORD 63,64,65,64,64,64,48,97
					DWORD 64,63,65,64,64,64,45,95
					DWORD 64,63,65,64,64,64,42,93
					DWORD 64,63,65,64,64,64,40,91
					DWORD 64,63,65,64,64,64,37,88
					DWORD 64,63,65,64,64,64,35,86
					DWORD 64,63,65,64,64,64,33,83
					DWORD 64,63,64,65,64,64,31,80
					DWORD 64,63,64,65,64,64,30,76
					DWORD 64,63,64,65,64,64,29,73
					DWORD 64,63,64,65,64,64,28,68

					DWORD 64,63,64,65,64,64,28,64
					DWORD 64,63,64,65,64,64,28,60
					DWORD 64,63,64,65,64,64,29,55
					DWORD 64,63,64,65,64,64,30,52
					DWORD 64,63,64,65,64,64,31,48
					DWORD 65,64,64,65,64,64,33,45
					DWORD 65,64,64,65,64,64,35,42
					DWORD 65,64,64,65,64,64,37,40
					DWORD 65,64,64,65,64,64,40,37
					DWORD 65,64,64,65,64,64,42,35
					DWORD 65,64,64,65,64,64,45,33
					DWORD 63,64,65,64,64,64,48,31
					DWORD 63,64,65,64,64,64,52,30
					DWORD 63,64,65,64,64,64,55,29
					DWORD 63,64,65,64,64,64,60,28


.CODE
;
; Macros
;


.CODE
;
; les procdures gnriques
;
INCLUDE GenericProcs.asm


.CODE
;
; les procdures spcifiquement cres pour le programme
;


ALIGN 16
;
; ici, on inclus l'indispensable procdure de gestion des messages entre l'application et windows...
; elle traite les messages spcifiques, les autres sont retransmis au gestionnaire par defaut de windows.
; chaque message peut avoir une valeur additionnelle associe (situe dans les paramtres WParam et LParam).
; le rang de donnes additionnelle qui peuvent tre obtenues par l'application est dtermin par la nature du message.
;
; Rceptionne :
; rien (hormis les messages du systme d'exploitation, mais ca se fait automatiquement)
;
; Retourne:
; rien (mais attention eax est modifi)
;
GestionnaireMessagesBoiteDialoguePrincipale PROC HWndGMHor:DWORD,Message:DWORD,WParam:DWORD,LParam:DWORD
;LOCAL DessinEcran :PAINTSTRUCT

		mov eax,Message								;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

;
; initialisation des controleurs
;
		cmp eax,WM_INITDIALOG							;; comparer eax  WM_INITDIALOG
		jne GMHorFinInitialisationControleurs				;; si ce n'est pas le cas, aller GMHorFinInitialisationControleurs
		invoke LoadIcon,HWndGMHor,Rsrc_IDI_Icone_32
		invoke SetClassLong,HWndGMHor,GCL_HICON,eax

; obtenir la taille de la fentre
		invoke GetClientRect,HWndGMHor,ADDR Horloge_Taille_Fenetre	;; remplir la structure RECT correspondante

; positionner la fentre sur la droite de notre cran (en la centrant en hauteur)
		mov esi,HWndGMHor								;; ) positionner la fentre outil
		mov edi,OFFSET Horloge_Coordonnees_Fenetre			;; )
		call PositionnerFenetreOutil						;; )

; on cr un pointeur pour le device context
		invoke GetDC,HWndGMHor							;; obtenir le pointeur
		mov Horloge_Pointeur_DC_Fenetre,eax				;; et le sauvegarder

; remplir la structure BITMAPINFO (pour la visualisation) avec les variables requises
		mov Horloge_Informations_Bitmap.biSize,SIZEOF BITMAPINFOHEADER	;; taille de la structure BITMAPINFOHEADER
		mov eax,Horloge_Taille_Fenetre.right				;; ) la largeur
		mov Horloge_Informations_Bitmap.biWidth,eax			;; )
		mov eax,Horloge_Taille_Fenetre.bottom				;;	)la hauteur (ngative, pour que la premire ligne soit celle du haut, et pas celle du bas)
		neg eax										;;	)
		mov Horloge_Informations_Bitmap.biHeight,eax			;;	)
		mov Horloge_Informations_Bitmap.biPlanes,1			;;
		mov Horloge_Informations_Bitmap.biBitCount,32		;; pour des couleurs 32 bits
		mov Horloge_Informations_Bitmap.biCompression,BI_RGB	;; (BI_RGB=pas de compression)

; charger l'image de fond
		mov edi,OFFSET Horloge_Chaine_Chemin_Et_Nom_Fichier	;; ) obtenir le rpertoire en cours
		call ObtenirRepertoireEnCours						;; )
		mov esi,OFFSET Horloge_Chaine_Nom_Fichier			;;	) construire la chaine contenant le chemin et le nom du fichier bmp
		mov edi,OFFSET Horloge_Chaine_Chemin_Et_Nom_Fichier	;;	)
		call FusionnerChainesAscii						;;	)
		mov ebx,OFFSET Horloge_Chaine_Chemin_Et_Nom_Fichier	;; ) charger le fichier bmp
		mov ecx,OFFSET Horloge_Pointeurs_Bitmap_Charge		;; )
		mov esi,OFFSET Instance_Memoire					;; )
		mov edi,OFFSET Horloge_Tampon_Bitmap_Charge			;; )
		call ChargerFichier_Bmp							;; )

; ici, on rcupre le bitmap
		cmp eax,0										;; comparer eax  0
		jle GMHorEviterRecupererPixels					;; si c'est infrieur ou gal  0, aller GMHorEviterRecupererPixels
		mov ebx,(_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Informations_Bitmap_
; obtenir la largeur et la hauteur du DIB (Device Independant Bitmap)
		cmp (BITMAPINFOHEADER PTR [ebx]).biSize,SIZEOF BITMAPCOREHEADER	;; structure BITMAPCOREHEADER ?
		jne GMHorTraitementParBMI						;; si ce n'est pas le cas, aller GMHorTraitementParBMI
GMHorTraitementParBCH:
; ici, la largeur et la hauteur sont des WORDs (fichier constitu de triples octets)
		movzx eax,(BITMAPCOREHEADER PTR [ebx]).bcWidth		;; ) obtenir la largeur du bitmap
		mov Horloge_Largeur_Bitmap_En_Pixels,eax			;; )
		movzx eax,(BITMAPCOREHEADER PTR [ebx]).bcHeight		;;	) obtenir la hauteur du bitmap
		mov Horloge_Hauteur_Bitmap_En_Pixels,eax			;;	)
		jmp GMHorTaillesBitmapDefinies					;; aller GMHorTaillesBitmapDefinies
GMHorTraitementParBMI:
; ici, la largeur et la hauteur sont des DWORDs (fichier constitu de quadruples octets)
		mov eax,(BITMAPINFOHEADER PTR [ebx]).biWidth			;; ) obtenir la largeur du bitmap
		mov Horloge_Largeur_Bitmap_En_Pixels,eax			;; )
		mov eax,(BITMAPINFOHEADER PTR [ebx]).biHeight		;;	) obtenir la hauteur du bitmap
		test eax,eax									;;	)
		jns GMHorEviterRendrePositif						;;	)
		neg eax										;;	)
GMHorEviterRendrePositif:
		mov Horloge_Hauteur_Bitmap_En_Pixels,eax			;;	)
GMHorTaillesBitmapDefinies:
; remplir la structure BITMAPINFOHEADER de sauvegarde (elle va aussi servir pour rcuprer les pixels)
		mov eax,Horloge_Largeur_Bitmap_En_Pixels			;; )
		mov ebx,Horloge_Hauteur_Bitmap_En_Pixels			;; )
		mov Horloge_Entete_Informations_Bitmap.biSize,SIZEOF BITMAPINFOHEADER	;; placer la taiile de la structure BITMAPINFOHEADER
		mov Horloge_Entete_Informations_Bitmap.biWidth,eax	;; placer la largeur
		neg ebx										;;	) placer la hauteur
		mov Horloge_Entete_Informations_Bitmap.biHeight,ebx	;;	)
		mov Horloge_Entete_Informations_Bitmap.biPlanes,1		;; nombre de plans (doit tre gal  1)
		mov Horloge_Entete_Informations_Bitmap.biBitCount,32	;; placer le nombre de bits par pixels
		mov Horloge_Entete_Informations_Bitmap.biCompression,BI_RGB	;; placer le format non comprss
		mov Horloge_Entete_Informations_Bitmap.biSizeImage,0		;; ) s'assurer que c'est vide
		mov Horloge_Entete_Informations_Bitmap.biXPelsPerMeter,0	;; )
		mov Horloge_Entete_Informations_Bitmap.biYPelsPerMeter,0	;; )
		mov Horloge_Entete_Informations_Bitmap.biClrUsed,0	;; placer le nombre de couleurs
		mov Horloge_Entete_Informations_Bitmap.biClrImportant,0	;; placer le nombre des couleurs importantes

; rcuprer les pixels du fichier charg en mmoire (ouaip, je sais... les quelques lignes qui suivent ce n'est pas
; vraiment de l'assembleur, mais avec le systme utilis par windows on a pas trop le choix...)
		invoke CreateDC,ADDR Chaine_Display,NULL,NULL,NULL
		mov Horloge_Pointeur_DC_Temporaire,eax				;; sauvegarder le pointeur obtenu
		invoke CreateCompatibleDC,Horloge_Pointeur_DC_Temporaire
		mov Horloge_Pointeur_DC_Compatible,eax				;; sauvegarder le pointeur obtenu
		invoke CreateDIBSection,Horloge_Pointeur_DC_Compatible,ADDR Horloge_Entete_Informations_Bitmap,DIB_RGB_COLORS,ADDR Horloge_Pointeur_Pixels_Recuperes,NULL,NULL
		mov Horloge_Pointeur_Nouveau_Dib,eax
		invoke SelectObject,Horloge_Pointeur_DC_Compatible,Horloge_Pointeur_Nouveau_Dib
		invoke SetDIBitsToDevice,Horloge_Pointeur_DC_Compatible,NULL,NULL,Horloge_Largeur_Bitmap_En_Pixels,Horloge_Hauteur_Bitmap_En_Pixels,NULL,NULL,NULL,Horloge_Hauteur_Bitmap_En_Pixels,Horloge_Pointeurs_Bitmap_Charge._Pointeur_Pixels_Du_Bitmap_,Horloge_Pointeurs_Bitmap_Charge._Pointeur_Informations_Bitmap_,DIB_RGB_COLORS

; crer l'cran du fond
		mov eax,Horloge_Largeur_Bitmap_En_Pixels			;; ) allouer un espace mmoire pour notre tampon du fond
		mov ebx,Horloge_Hauteur_Bitmap_En_Pixels			;; )
		mov esi,OFFSET Instance_Memoire					;; )
		mov edi,OFFSET Horloge_Tampon_Image_Fond			;; )
		call CreerEcran								;; )

; crer l'cran final
		mov eax,Horloge_Largeur_Bitmap_En_Pixels			;; ) allouer un espace mmoire pour notre tampon ecran visualisation
		mov ebx,Horloge_Hauteur_Bitmap_En_Pixels			;; ) (ici, avec dbuffer)
;		mov esi,OFFSET Instance_Memoire					;; )
		mov edi,OFFSET Horloge_Tampon_Ecran_Final			;; )
		call CreerEcranAvecDBuffer						;; )

; ici, recopier simplement les pixels
		mov eax,Horloge_Tampon_Image_Fond._Taille_Du_Bloc_	;; ) copier le bloc
		mov esi,Horloge_Pointeur_Pixels_Recuperes			;; )
		mov edi,Horloge_Tampon_Image_Fond._Pointeur_			;; )
		call CopierBlocMemoire							;; )
; supprimer les salets windows dont on n'a plus besoin (c'est pas trop tt...)
		invoke DeleteObject,Horloge_Pointeur_Nouveau_Dib		;; ) supprimer les pointeurs/devices devenus inutiles
		invoke DeleteDC,Horloge_Pointeur_DC_Compatible		;; ) (ne peut tre fait tant qu'on a besoin de Pointeur_Pixels_Recuperes)
		invoke DeleteDC,Horloge_Pointeur_DC_Temporaire		;; )
GMHorEviterRecupererPixels:

; supprimer le bitmap charg (devenu inutile...)
		mov esi,OFFSET Instance_Memoire					;; ) supprimer le bitmap en mmoire
		mov edi,OFFSET Horloge_Tampon_Bitmap_Charge			;; )
		call SupprimerBlocMemoire						;; )

	ret												;; retourner
GMHorFinInitialisationControleurs:


;;
;; initialisation de la fentre
;;
;		cmp eax,WM_CREATE
;		jne GMHorFinInitialisation						;; si ce n'est pas le cas, aller GMHorFinInitialisation
;
;	ret												;; retourner
;GMHorFinInitialisation:


;
; mouvement de la fentre
;
		cmp eax,WM_MOVE								;; mouvement de la fentre ?
		je GMHorAffichage								;; si c'est le cas, aller GMHorAffichage


;
; dessin de la fentre
;
		cmp eax,WM_PAINT								;; mise  jour de la fentre ?
		jne GMHorFinMiseAJourFenetre						;; si ce n'est pas le cas, aller GMHorFinMiseAJourFenetre


;
; dfinir/mettre  jour les informations concernant l'heure
;
		call DefinirDateEtHeure							;; mettre  jour la date et l'heure
; on test si les secondes ont changes
		movzx edx,_Date_Informations_Date_.wSecond			;; lire le nombre de secondes
		cmp edx,Horloge_Temoin_Secondes					;; comparer  la dernire sauvegarde tmoin
		je GMHorEviterAffichage							;; tant que c'est semblable, aller GMHorEviterAffichage


;
; si changement, construire la chane d'information (la chane titre de la fentre)
;
		movzx eax,_Date_Informations_Date_.wDay				;; lire le jour
		cmp eax,Horloge_Temoin_Jours						;; comparer  la sauvegarde tmoin
		jne GMHorMiseAJourTitreFenetre					;; si c'est diffrent, aller GMHorMiseAJourTitreFenetre
		movzx ebx,_Date_Informations_Date_.wMonth			;; lire le mois
		cmp ebx,Horloge_Temoin_Mois						;; comparer  la sauvegarde tmoin
		jne GMHorMiseAJourTitreFenetre					;; si c'est diffrent, aller GMHorMiseAJourTitreFenetre
		movzx ecx,_Date_Informations_Date_.wYear			;; lire l'anne
		cmp ecx,Horloge_Temoin_Annees						;; comparer  la sauvegarde tmoin
		je GMHorEviterMiseAJourTitreFenetre				;; si c'est gal (tout est semblable), aller GMHorEviterMiseAJourTitreFenetre
GMHorMiseAJourTitreFenetre:
		mov Horloge_Temoin_Jours,eax						;; ) sauvegarder les changements
		mov Horloge_Temoin_Mois,ebx						;; )
		mov Horloge_Temoin_Annees,ecx						;; )
		mov edi,OFFSET Horloge_Chaine_Titre_Fenetre			;;	) obtenir la chaine contenant la date
		mov BYTE PTR [edi],0							;;	) (ici, il faut nettoyer sinon, ce sera ajout  la suite...)
		call ObtenirDate								;;	)
		invoke SetWindowText,HWndGMHor,ADDR Horloge_Chaine_Titre_Fenetre	;; mise  jour du titre de la fentre
GMHorEviterMiseAJourTitreFenetre:


;
; dessiner le fond
;
		mov eax,Horloge_Tampon_Ecran_Final._Taille_Du_Bloc_	;; ) copier le fond
		mov esi,Horloge_Tampon_Image_Fond._Pointeur_			;; )
		mov edi,Horloge_Tampon_Ecran_Final._Pointeur_		;; )
		call CopierBlocMemoire							;; )


;
; dessiner les 3 aiguilles
;

; pour les secondes
		movzx edx,_Date_Informations_Date_.wSecond			;; lire le nombre de secondes
		mov Horloge_Temoin_Secondes,edx					;; effectuer la sauvegarde tmoin
		shl edx,5										;; multiplier le nombre par 32 (8 dwords)
		add edx,OFFSET Table_positions_Minutes				;; ajouter l'adresse de la table des positions
		mov Horloge_Pointeur_Temporaire,edx				;; sauver le pointeur dans la table
		mov eax,DWORD PTR [edx+DWORD*6]					;; ) dessiner le 1er bord de l'aiguille pour les secondes
		mov ebx,DWORD PTR [edx+DWORD*7]					;; )
		mov ecx,DWORD PTR [edx]							;; )
		mov edx,DWORD PTR [edx+DWORD]						;; )
		mov esi,OFFSET Horloge_Tampon_Ecran_Final			;; )
		mov edi,03F9F9F9Fh								;; )
		call Mmx_DessinerLigne_Alpha						;; )
		mov edx,Horloge_Pointeur_Temporaire				;; relire le pointeur dans la table
		mov eax,DWORD PTR [edx+DWORD*6]					;;	) dessiner le 2eme bord de l'aiguille pour les secondes
		mov ebx,DWORD PTR [edx+DWORD*7]					;;	)
		mov ecx,DWORD PTR [edx+DWORD*2]					;;	)
		mov edx,DWORD PTR [edx+DWORD*3]					;;	)
;		mov esi,OFFSET Horloge_Tampon_Ecran_Final			;;	)
;		mov edi,03F9F9F9Fh								;;	)
		call Mmx_DessinerLigne_Alpha						;;	)
		mov edx,Horloge_Pointeur_Temporaire				;; relire le pointeur dans la table
		mov eax,DWORD PTR [edx+DWORD*6]					;; ) dessiner l'aiguille pour les secondes
		mov ebx,DWORD PTR [edx+DWORD*7]					;; )
		mov ecx,DWORD PTR [edx+DWORD*4]					;; )
		mov edx,DWORD PTR [edx+DWORD*5]					;; )
;		mov esi,OFFSET Horloge_Tampon_Ecran_Final			;; )
		mov edi,07F7F7F7Fh								;; )
		call Mmx_DessinerLigne_Alpha						;; )

; pour les minutes
		movzx edx,_Date_Informations_Date_.wMinute			;; lire le nombre de minutes
		shl edx,5										;; multiplier le nombre par 32 (8 dwords)
		add edx,OFFSET Table_positions_Minutes				;; lire l'adresse de la table des positions
		mov Horloge_Pointeur_Temporaire,edx				;; sauver le pointeur dans la table
		mov eax,DWORD PTR [edx+DWORD*6]					;; ) dessiner le 1er bord de l'aiguille pour les minutes
		mov ebx,DWORD PTR [edx+DWORD*7]					;; )
		mov ecx,DWORD PTR [edx]							;; )
		mov edx,DWORD PTR [edx+DWORD]						;; )
;		mov esi,OFFSET Horloge_Tampon_Ecran_Final			;; )
		mov edi,05F7F7F7Fh								;; )
		call Mmx_DessinerLigne_Alpha						;; )
		mov edx,Horloge_Pointeur_Temporaire				;; relire le pointeur dans la table
		mov eax,DWORD PTR [edx+DWORD*6]					;;	) dessiner le 2eme bord de l'aiguille pour les minutes
		mov ebx,DWORD PTR [edx+DWORD*7]					;;	)
		mov ecx,DWORD PTR [edx+DWORD*2]					;;	)
		mov edx,DWORD PTR [edx+DWORD*3]					;;	)
;		mov esi,OFFSET Horloge_Tampon_Ecran_Final			;;	)
;		mov edi,05F7F7F7Fh								;;	)
		call Mmx_DessinerLigne_Alpha						;;	)
		mov edx,Horloge_Pointeur_Temporaire				;; relire le pointeur dans la table
		mov eax,DWORD PTR [edx+DWORD*6]					;; ) dessiner l'aiguille pour les minutes
		mov ebx,DWORD PTR [edx+DWORD*7]					;; )
		mov ecx,DWORD PTR [edx+DWORD*4]					;; )
		mov edx,DWORD PTR [edx+DWORD*5]					;; )
;		mov esi,OFFSET Horloge_Tampon_Ecran_Final			;; )
		mov edi,0DF3F3F3Fh								;; )
		call Mmx_DessinerLigne_Alpha						;; )

; pour les heures (augmentation d'1 cran toutes les 12 minutes)
		movzx ecx,_Date_Informations_Date_.wHour			;; lire le nombre d'heures
		cmp ecx,12									;; comparer ce nombre  12
		jl GMHorHeuresMatinales							;; si c'est infrieur aller GMHorHeuresMatinales
		sub ecx,12									;; sinon, enlever les 12 heures matinales
GMHorHeuresMatinales:
		mov eax,5*32									;; ) multiplier la valeur par 5 et par 8 dwords
		mul ecx										;; )
		mov ecx,eax									;; )
; puis, ajouter le dcalage correspondant aux minutes
		xor edx,edx									;; nettoyer edx
		movzx eax,_Date_Informations_Date_.wMinute			;; lire le nombre de minutes
		mov ebx,357913942								;; ) diviser par 12 (60/5, pour obtenir une valeur additionelle allant de 0  4)
		mul ebx										;; )
		shl edx,5										;; multiplier le rsultat par 32 (8 dwords)
		add edx,ecx									;; ajouter ecx au rsultat en edx
		add edx,OFFSET Table_positions_Heures				;; lire l'adresse de la table des positions
		mov Horloge_Pointeur_Temporaire,edx				;; sauver le pointeur dans la table
		mov eax,DWORD PTR [edx+DWORD*6]					;; ) dessiner le 1er bord de l'aiguille pour les heures
		mov ebx,DWORD PTR [edx+DWORD*7]					;; )
		mov ecx,DWORD PTR [edx]							;; )
		mov edx,DWORD PTR [edx+DWORD]						;; )
;		mov esi,OFFSET Horloge_Tampon_Ecran_Final			;; )
		mov edi,05F7F7F7Fh								;; )
		call Mmx_DessinerLigne_Alpha						;; )
		mov edx,Horloge_Pointeur_Temporaire				;; relire le pointeur dans la table
		mov eax,DWORD PTR [edx+DWORD*6]					;;	) dessiner le 2eme bord de l'aiguille pour les heures
		mov ebx,DWORD PTR [edx+DWORD*7]					;;	)
		mov ecx,DWORD PTR [edx+DWORD*2]					;;	)
		mov edx,DWORD PTR [edx+DWORD*3]					;;	)
;		mov esi,OFFSET Horloge_Tampon_Ecran_Final			;;	)
;		mov edi,05F7F7F7Fh								;;	)
		call Mmx_DessinerLigne_Alpha						;;	)
		mov edx,Horloge_Pointeur_Temporaire				;; relire le pointeur dans la table
		mov eax,DWORD PTR [edx+DWORD*6]					;; ) dessiner l'aiguille pour les heures
		mov ebx,DWORD PTR [edx+DWORD*7]					;; )
		mov ecx,DWORD PTR [edx+DWORD*4]					;; )
		mov edx,DWORD PTR [edx+DWORD*5]					;; )
;		mov esi,OFFSET Horloge_Tampon_Ecran_Final			;; )
		mov edi,0DF3F3F3Fh								;; )
		call Mmx_DessinerLigne_Alpha						;; )


; et envoyer le rsultat  l'affichage
		mov edi,OFFSET Horloge_Tampon_Ecran_Final			;; ) l'affichage est effectu, donc on met  jour le dbuffer
		call MiseAJourDBuffer							;; )
GMHorAffichage:
		invoke SetDIBitsToDevice,Horloge_Pointeur_DC_Fenetre,NULL,NULL,Horloge_Tampon_Ecran_Final._Largeur_Ecran_,Horloge_Tampon_Ecran_Final._Hauteur_Ecran_,NULL,NULL,NULL,Horloge_Tampon_Ecran_Final._Hauteur_Ecran_,Horloge_Tampon_Ecran_Final._Pointeur_,ADDR Horloge_Informations_Bitmap,DIB_RGB_COLORS

;		invoke Sleep,1									;; patienter un peu...
GMHorEviterAffichage:
	ret												;; retourner
GMHorFinMiseAJourFenetre:


;
; ici, les messages concernant la souris :
; WM_LBUTTONDOWN, WM_LBUTTONUP, WM_LBUTTONDBLCLK,
; WM_MBUTTONDOWN, WM_MBUTTONUP, WM_MBUTTONDBLCLK,
; WM_RBUTTONDOWN, WM_RBUTTONUP, WM_RBUTTONDBLCLK, WM_MOUSEMOVE
; retournent le rsultat obtenu par les boutons et le mouvement de la souris.
;

;;
;; bouton gauche press ?
;;
;		cmp eax,WM_LBUTTONDOWN							;; bouton gauche de la souris press ?
;		jne GMHorPasBoutonSourisGauche					;; si ce n'est pas le cas, aller GMHorPasBoutonSourisGauche
;
;	ret												;; retourner
;GMHorPasBoutonSourisGauche:
;
;;
;; bouton gauche relach ?
;;
;		cmp eax,WM_LBUTTONUP							;; bouton gauche de la souris relach ?
;		jne GMHorPasBoutonSourisGaucheRelache				;; si ce n'est pas le cas, aller GMHorPasBoutonSourisGaucheRelache
;
;	ret												;; retourner
;GMHorPasBoutonSourisGaucheRelache:
;
;;;
;;; double clique gauche ?
;;;
;;		cmp eax,WM_LBUTTONDBLCLK							;; bouton gauche de la souris double clique ?
;;		jne GMHorPasBoutonSourisGaucheDouble				;; si ce n'est pas le cas, aller GMHorPasBoutonSourisGaucheDouble
;;
;;;	ret												;; retourner
;;GMHorPasBoutonSourisGaucheDouble:
;;
;; bouton milieu press ?
;;
;		cmp eax,WM_MBUTTONDOWN							;; bouton milieu de la souris press ?
;		jne GMHorPasBoutonSourisMilieu					;; si ce n'est pas le cas, aller GMHorPasBoutonSourisMilieu
;
;;	ret												;; retourner
;GMHorPasBoutonSourisMilieu:
;;
;;  bouton milieu relach ?
;;
;		cmp eax,WM_MBUTTONUP							;; bouton milieu de la souris relach ?
;		jne GMHorPasBoutonSourisMilieuRelache				;; si ce n'est pas le cas, aller GMHorPasBoutonSourisMilieuRelache
;
;;	ret												;; retourner
;GMHorPasBoutonSourisMilieuRelache:
;;;
;;; double clique milieu ?
;;;
;;		cmp eax,WM_MBUTTONDBLCLK							;; bouton milieu de la souris double clique ?
;;		jne GMHorPasBoutonSourisMilieuDouble				;; si ce n'est pas le cas, aller GMHorPasBoutonSourisMilieuDouble
;;
;;;	ret												;; retourner
;;GMHorPasBoutonSourisMilieuDouble:
;;
;; bouton droit press ?
;;
;		cmp eax,WM_RBUTTONDOWN							;; bouton droit de la souris press ?
;		jne GMHorPasBoutonSourisDroit						;; si ce n'est pas le cas, aller GMHorPasBoutonSourisDroit
;
;;	ret												;; retourner
;GMHorPasBoutonSourisDroit:
;;
;; bouton droit relach ?
;;
;		cmp eax,WM_RBUTTONUP							;; bouton droit de la souris relach ?
;		jne GMHorPasBoutonSourisDroitRelache				;; si ce n'est pas le cas, aller GMHorPasBoutonSourisDroitRelache
;
;;	ret												;; retourner
;GMHorPasBoutonSourisDroitRelache:
;;;
;;; double clique droit ?
;;;
;;		cmp eax,WM_RBUTTONDBLCLK							;; bouton droit de la souris double clique ?
;;		jne GMHorPasBoutonSourisDroitDouble				;; si ce n'est pas le cas, aller GMHorPasBoutonSourisDroitDouble
;;
;;;	ret												;; retourner
;;GMHorPasBoutonSourisDroitDouble:

;;
;; mouvement de la souris ?
;;
;		cmp eax,WM_MOUSEMOVE							;; un mouvement de la souris ?
;		jne GMHorPasMouvementsSouris						;; si ce n'est pas le cas, aller GMHorPasMouvementsSouris
;; ici, on traite la rotation par rapport  l'axe Y (mouvement souris X)
;		mov eax,LParam									;; sinon on place LParam (Y (word), X (word)) dans eax
;		and eax,00000FFFFh								;; filtrer eax (pour avoir uniquement le X)
;		mov eax,LParam									;; on place LParam (Y (word), X (word)) dans eax
;		shr eax,16									;; dcaler eax  droite de 16 bits (pour avoir l'Y au bon endroit)
;;		mov eax,WParam									;; pas utile pour le moment...
;
;	ret												;; retourner
;GMHorPasMouvementsSouris:



;;
;; mouvement de la molette de la souris ?
;;
;		cmp eax,WM_MOUSEWHEEL							;; un mouvement de la molette de la souris ?
;		jne GMHorPasMouvementsMoletteSouris				;; si ce n'est pas le cas, aller GMHorPasMouvementsMoletteSouris
;		and eax,0FFFF0000h								;; ne conserver que les 16 bits suprieurs (ce sont eux qui contiennent les infos)
;		js GMHorMouvementMoletteSourisSuivant
;; il faut diviser la valeur par 120 (?) pour avoir la valeur de dplacement
;		shr eax,16
;
;
;		jmp GMHorMouvementMoletteSourisPrecedent
;GMHorMouvementMoletteSourisSuivant:
;; il faut diviser la valeur par 120 (?) pour avoir la valeur de dplacement
;		neg eax
;		shr eax,16
;
;
;GMHorMouvementMoletteSourisPrecedent:
;	ret												;; retourner
;GMHorPasMouvementsMoletteSouris:


;;
;; ici, les messages concernant les touches prsses
;;
;		cmp eax,WM_KEYDOWN								;; une touche est presse ?
;		jne GMHorFinTouchePressee						;; si ce n'est pas le cas, aller GMHorFinTouchePressee
;		mov eax,WParam									;; placer WParam (le code de la touche) dans eax

;;
;; touche esc presse ?
;;
;		cmp eax,VK_ESCAPE								;; Quitter ?
;		jne GMHorPasToucheEscPressee						;; si ce n'est pas le cas, aller GMHorPasToucheEscPressee
;		bts Temoins_Boites_De_Dialogue,0					;; placer le tmoin de la boite de dialogue pour quitter (bit 0)
;		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Quitter,0,ADDR GestionnaireMessagesBoitesDialogue,0
;	ret												;; retourner
;GMHorPasToucheEscPressee:

;;
;; touche F1 presse ?
;;
;		cmp eax,VK_F1
;		jne GMHorPasToucheF1Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF1Pressee
;
;	ret												;; retourner
;GMHorPasToucheF1Pressee:

;;
;; touche F2 presse ?
;;
;		cmp eax,VK_F2
;		jne GMHorPasToucheF2Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF2Pressee
;
;	ret												;; retourner
;GMHorPasToucheF2Pressee:

;;
;; touche F3 presse ?
;;
;		cmp eax,VK_F3
;		jne GMHorPasToucheF3Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF3Pressee
;
;	ret												;; retourner
;GMHorPasToucheF3Pressee:

;;
;; touche F4 presse ?
;;
;		cmp eax,VK_F4
;		jne GMHorPasToucheF4Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF4Pressee
;
;	ret												;; retourner
;GMHorPasToucheF4Pressee:

;;
;; touche F5 presse ?
;;
;		cmp eax,VK_F5
;		jne GMHorPasToucheF5Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF5Pressee
;
;	ret												;; retourner
;GMHorPasToucheF5Pressee:

;;
;; touche F6 presse ?
;;
;		cmp eax,VK_F6
;		jne GMHorPasToucheF6Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF6Pressee
;
;	ret												;; retourner
;GMHorPasToucheF6Pressee:

;;
;; touche F7 presse ?
;;
;		cmp eax,VK_F7
;		jne GMHorPasToucheF7Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF7Pressee
;
;	ret												;; retourner
;GMHorPasToucheF7Pressee:

;;
;; touche F8 presse ?
;;
;		cmp eax,VK_F8
;		jne GMHorPasToucheF8Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF8Pressee
;
;	ret												;; retourner
;GMHorPasToucheF8Pressee:

;;
;; touche F9 presse ?
;;
;		cmp eax,VK_F9
;		jne GMHorPasToucheF9Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF9Pressee
;


;	ret												;; retourner
;GMHorPasToucheF9Pressee:

;;
;; touche F10 presse ?
;;
;		cmp eax,VK_F10
;		jne GMHorPasToucheF10Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF11Pressee
;
;	ret												;; retourner
;GMHorPasToucheF10Pressee:

;;
;; touche F11 presse ?
;;
;		cmp eax,VK_F11
;		jne GMHorPasToucheF11Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF11Pressee
;
;	ret												;; retourner
;GMHorPasToucheF11Pressee:

;;
;; touche F12 presse ?
;;
;		cmp eax,VK_F12
;		jne GMHorPasToucheF12Pressee						;; si ce n'est pas le cas, aller GMHorPasToucheF12Pressee
;
;	ret												;; retourner
;GMHorPasToucheF12Pressee:

;;
;; touche haut presse ?
;;
;		cmp eax,VK_UP
;		jne GMHorPasToucheHautPressee						;; si ce n'est pas le cas, aller GMHorPasToucheHautPressee
;
;	ret												;; retourner
;GMHorPasToucheHautPressee:

;;
;; touche bas presse ?
;;
;		cmp eax,VK_DOWN
;		jne GMHorPasToucheBasPressee						;; si ce n'est pas le cas, aller GMHorPasToucheBasPressee
;
;	ret												;; retourner
;GMHorPasToucheBasPressee:

;;
;; touche gauche presse ?
;;
;		cmp eax,VK_LEFT
;		jne GMHorPasToucheGauchePressee					;; si ce n'est pas le cas, aller GMHorPasToucheGauchePressee
;
;	ret												;; retourner
;GMHorPasToucheGauchePressee:

;;
;; touche droite presse ?
;;
;		cmp eax,VK_RIGHT
;		jne GMHorPasToucheDroitePressee					;; si ce n'est pas le cas, aller GMHorPasToucheDroitePressee
;
;	ret												;; retourner
;GMHorPasToucheDroitePressee:

;;
;; touche page precedente presse ?
;;
;		cmp eax,VK_PGUP								;; touche page prcedente ?
;		jne GMHorPasTouchePagePrecedantePressee				;; si ce n'est pas le cas, aller GMHorPasTouchePagePrecedantePressee
;
;	ret												;; retourner
;GMHorPasTouchePagePrecedantePressee:

;;
;; touche page suivate presse ?
;;
;		cmp eax,VK_PGDN								;; touche page suivante ?
;		jne GMHorPasTouchePageSuivantePressee				;; si ce n'est pas le cas, aller GMHorPasTouchePageSuivantePressee
;
;	ret												;; retourner
;GMHorPasTouchePageSuivantePressee:

;;
;; touche a presse ?
;;
;		cmp eax,VK_A
;		jne GMHorPasToucheAPressee						;; si ce n'est pas le cas, aller GMHorPasToucheAPressee
;
;	ret												;; retourner
;GMHorPasToucheAPressee:

;;
;	ret												;; retourner
;GMHorFinTouchePressee:


;;
;; ici, les messages concernant les touches relaches
;;
;		cmp eax,WM_KEYUP
;		jne GMHorFinToucheRelachee						;; si ce n'est pas le cas, aller GMHorFinToucheRelachee
;		mov eax,WParam
;;
;; touche haut relache ?
;;
;		cmp eax,VK_UP
;		jne GMHorPasToucheHautRelachee					;; si ce n'est pas le cas, aller GMHorPasToucheHautRelachee
;
;	ret												;; retourner
;GMHorPasToucheHautRelachee:
;;
;; touche bas relache ?
;;
;		cmp eax,VK_DOWN
;		jne GMHorPasToucheBasRelachee						;; si ce n'est pas le cas, aller GMHorPasToucheBasRelachee
;
;	ret												;; retourner
;GMHorPasToucheBasRelachee:

;;
;; touche gauche relache ?
;;
;		cmp eax,VK_LEFT
;		jne GMHorPasToucheGaucheRelachee					;; si ce n'est pas le cas, aller GMHorPasToucheGaucheRelachee
;
;	ret												;; retourner
;GMHorPasToucheGaucheRelachee:
;;
;; touche droite relache ?
;;
;		cmp eax,VK_RIGHT
;		jne GMHorPasToucheDroiteRelachee					;; si ce n'est pas le cas, aller GMHorPasToucheDroiteRelachee
;
;	ret												;; retourner
;GMHorPasToucheDroiteRelachee:
;;
;; touche page precedente relache ?
;;
;		cmp eax,VK_PGUP								;; touche page prcedente ?
;		jne GMHorPasTouchePagePrecedanteRelachee				;; si ce n'est pas le cas, aller GMHorPasTouchePagePrecedanteRelachee
;
;	ret												;; retourner
;GMHorPasTouchePagePrecedanteRelachee:
;;
;; touche page suivate relache ?
;;
;		cmp eax,VK_PGDN								;; touche page suivante ?
;		jne GMHorPasTouchePageSuivanteRelachee				;; si ce n'est pas le cas, aller GMHorPasTouchePageSuivanteRelachee
;
;	ret												;; retourner
;GMHorPasTouchePageSuivanteRelachee:
;
;
;
;
;;
;	ret												;; retourner
;GMHorFinToucheRelachee:


;
; fermeture de l'application ?
;
		cmp eax,WM_CLOSE								;; message de fermeture reu ?
		jne GMHorPasFermeture							;; si ce n'est pas le cas, aller GMHorPasFermeture
		jmp GMHorSortir								;; sinon, idem WM_DESTROY
	ret												;; retourner
GMHorPasFermeture:


;
; quitter l'application
;
		cmp eax,WM_DESTROY								;; le message de sortie est reu ?
		jne GMHorPasQuitter								;; si ce n'est pas le cas, aller GMHorPasQuitter
GMHorSortir:
		bts Temoins_Boites_De_Dialogue,0					;; placer le tmoin de la boite de dialogue pour quitter (bit 0)

;		mov esi,OFFSET Instance_Memoire					;;	) supprimer l'cran pour le fond
;		mov edi,OFFSET Horloge_Tampon_Image_Fond			;;	)
;		call SupprimerEcran								;;	)
;;		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'cran dbuffer pour la visualisation
;		mov edi,OFFSET Horloge_Tampon_Ecran_Final			;; )
;		call SupprimerEcran								;; )
;		invoke DeleteDC,Horloge_Pointeur_DC_Fenetre			;; supprimer le device context

		invoke EnableWindow,HWndGMHor,FALSE
		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Quitter,0,ADDR GestionnaireMessagesBoitesDialogue,0
		invoke EnableWindow,HWndGMHor,TRUE
	ret												;; retourner (sortir de la procdure)
GMHorPasQuitter:


;
; traitement par dfaut pour les boites de dialogue
;
		xor eax,eax									;; effacer eax (ce sera le traitement par dfaut des messages)
	ret												;; retourner
GestionnaireMessagesBoiteDialoguePrincipale ENDP


ALIGN 16
;
; gestionnaire de message pour les boites de dialogue supplmentaires
;
GestionnaireMessagesBoitesDialogue PROC HWndGMBD:DWORD,Message:DWORD,WParam:DWORD,LParam:DWORD

		mov eax,Message								;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

		cmp eax,WM_COMMAND								;; une commande ?
		jne GMBDFinCommandes							;; si ce n'est pas le cas, aller GMBDFinCommandes
		mov eax,WParam									;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)
;
; boite de dialogue pour microprocesseur insuffisant
;

; Il est temps d'en changer...
		cmp eax,Rsrc_IDC_Temps_Changer					;; Il est temps d'en changer est cliqu ?
		jne GMBDPasTempsChangerMicro						;; si ce n'est pas le cas, aller GMBDPasTempsChangerMicro
		invoke EndDialog,HWndGMBD,0						;; sinon, fermer la boite de dialogue
		invoke PostQuitMessage,NULL						;; et poster le message de sortie
	ret												;; retourner
GMBDPasTempsChangerMicro:

;
; boite de dialogue pour quitter le programme
;

; hum... oui
		cmp eax,Rsrc_IDC_Hum_Oui							;; Hum... oui est cliqu ?
		jne GMBDPasHumOui								;; si ce n'est pas le cas, aller GMBDPasHumOui
		btr Temoins_Boites_De_Dialogue,0					;; enlever le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EndDialog,HWndGMBD,0						;; sinon, fermer la boite de dialogue
		invoke PostQuitMessage,NULL						;; poster le message de sortie
	ret												;; retourner
GMBDPasHumOui:
; Ah a non !
		cmp eax,Rsrc_IDC_Ah_Ca_Non						;; Ah a non ! est cliqu ?
		jne GMBDPasAhCaNon								;; si ce n'est pas le cas, aller GMBDPasAhCaNon
		btr Temoins_Boites_De_Dialogue,0					;; enlever le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EndDialog,HWndGMBD,0						;; sinon, fermer la boite de dialogue
;		invoke DialogBoxParam,Instance_Boite_Dialogue_Principale,Rsrc_IDD_Horloge_Fenetre,0,ADDR GestionnaireMessagesBoiteDialoguePrincipale,0
	ret												;; retourner
GMBDPasAhCaNon:

;;
;	ret												;; retourner
GMBDFinCommandes:


; traitement par dfaut pour les boites de dialogue
		xor eax,eax									;; effacer eax
	ret												;; retourner
GestionnaireMessagesBoitesDialogue ENDP


.CODE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Point d'entre du programme
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
ALIGN 16
Programme:
; initialisation
		invoke GetCommandLine							;;	) obtenir un pointeur sur la ligne de commande
		mov Pointeur_Ligne_Commandes,eax					;;	) et sauvegarder ce pointeur dans Pointeur_Ligne_Commandes
		invoke GetModuleHandle,NULL						;; ) obtenir l'instance de la fentre
		mov Instance_Application,eax						;; ) et sauvegarder le pointeur obtenu dans Instance_Application
;		mov Informations_Fenetre.hInstance,eax				;; ) ainsi que dans notre structure WNDCLASSEX
		invoke GetModuleHandle,NULL						;;	) obtenir l'instance des boites de dialogue
		mov Instance_Boite_Dialogue_Principale,eax			;;	) et sauvegarder le pointeur obtenu dans Instance_Boite_Dialogue_Principale
		invoke GetModuleHandle,NULL						;; ) obtenir l'instance des boites de dialogue
		mov Instance_Boites_Dialogue,eax					;; ) et sauvegarder le pointeur obtenu dans Instance_Boites_Dialogue
		mov esi,OFFSET Instance_Memoire					;;	) obtenir une instance mmoire
		call CreerInstanceMemoire						;;	)
;		call InitialiserNombresAleatoires					;; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.


;
; ici, on va tester le microprocesseur pour savoir si le minimum requis est disponible (on l'a pas fait avant parcequ'il fallait Pointeur_Fenetre)
;
		call DefinirAptitudesDuProcesseur
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
;		mov eax,_Temoins_Aptitudes_Du_MicroProcesseur_		;; copier les tmoins obtenus dans eax
;		mov edx,000000000001b							;; cpuid
;		mov edx,000000000011b							;; cpuid + fpu
;		mov edx,000000010011b							;; cpuid + fpu + cmov
		mov edx,000001010011b							;; cpuid + fpu + cmov + mmx
;		mov edx,000101010011b							;; cpuid + fpu + cmov + mmx + sse
;		mov edx,001101010011b							;; cpuid + fpu + cmov + mmx + sse + sse2
;		mov edx,101101010011b							;; cpuid + fpu + cmov + mmx + sse + sse2 + sse3
		and eax,edx									;; ici on ne conserve que les bits  tester dans eax
		cmp eax,edx									;; et on s'asure qu'ils sont tous l
		je MicroprocesseurSuffisant						;; si c'est gal (le microprocesseur a le minimum requis), aller MicroprocesseurSuffisant
; sinon on va afficher la boite de dialogue en consquence
;		invoke ReleaseCapture							;; librer les messages de la souris
;		invoke ShowCursor,Vrai							;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Insuffisant,0,ADDR GestionnaireMessagesBoitesDialogue,0
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
MicroprocesseurBoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL	;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL	;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL									;; comparer eax  zro
		je MicroprocesseurInsuffisant						;; si c'est gal  0 (pas de message), aller MicroprocesseurInsuffisant
;		invoke TranslateMessage,ADDR Informations_Messages_OS		;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS	;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessagesBoitesDialogue au moment voulu)
		jmp MicroprocesseurBoucleMessages					;; aller MicroprocesseurBoucleMessages (pour aller lire le message suivant)
MicroprocesseurSuffisant:


;
; sinon, le minimum requis est prsent
;

;
; appeler la boite de dialogue principale
;
		invoke DialogBoxParam,Instance_Boite_Dialogue_Principale,Rsrc_IDD_Horloge_Fenetre,NULL,ADDR GestionnaireMessagesBoiteDialoguePrincipale,NULL


;
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
;
BoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL	;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL	;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL									;; comparer eax  zro
		je FinBoucleMessages							;; si c'est gal  0 (pas de message), aller FinBoucleMessages
		invoke TranslateMessage,ADDR Informations_Messages_OS	;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS	;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessagesBoiteDialoguePrincipale au moment voulu)
		jmp BoucleMessages								;; aller BoucleMessages (pour aller lire le message suivant)
FinBoucleMessages:


;
; supprimer le device context
;
		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'cran dbuffer pour la visualisation
		mov edi,OFFSET Horloge_Tampon_Image_Fond			;; )
		call SupprimerEcran								;; )
;		mov esi,OFFSET Instance_Memoire					;;	) supprimer l'cran dbuffer pour la visualisation
		mov edi,OFFSET Horloge_Tampon_Ecran_Final			;;	)
		call SupprimerEcran								;;	)
		invoke DeleteDC,Horloge_Pointeur_DC_Fenetre			;; supprimer le device context


;
; et par ici la sortie...
;
MicroprocesseurInsuffisant:
		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'intance mmoire
		call SupprimerInstanceMemoire						;; )
		invoke ExitProcess,Informations_Messages_OS.wParam	;; sortie de l'application
;
; fin du programme
;
END Programme


